/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XLabel } from "./XLabel";
import { XInput } from "./XInput";
import { XSuffix } from "./XSuffix";
import { XIcon } from "./XIcon";
import { Popup } from "igniteui-react-layouts";
import { XCalendar } from "./XCalendar";
import { Rect } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { FirstWeek_$type } from "./FirstWeek";
import { DateFormats_$type } from "./DateFormats";
import { BrushUtil } from "igniteui-react-core";
import { DateTimeValueFormatter } from "./DateTimeValueFormatter";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { dateMinValue, dateMaxValue, dateGetDate, dateFromValues, dateGetMonth } from "igniteui-react-core";
import { stringContains, stringIsNullOrWhiteSpace, stringIsNullOrEmpty } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let DatePickerView = /*@__PURE__*/ (() => {
    class DatePickerView extends Base {
        constructor() {
            super();
            this.b = null;
            this.d = null;
            this.k = null;
            this.e = null;
            this.m = null;
            this.l = null;
            this.j = null;
            this.g = null;
            this.f = null;
            this.i = null;
            this.h = null;
        }
        ag() {
        }
        get n() {
            return this.e;
        }
        af(a) {
            if (a == null) {
                this.d = null;
                return;
            }
            this.d = a;
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.z();
            this.aa();
            let d = this.d.rootWrapper.getChildAt(0);
            d.listen("keydown", runOn(this, this.x));
            d.listen("focusin", runOn(this, this.v));
            d.listen("focusout", runOn(this, this.w));
            document.addEventListener("click", runOn(this, this.ab), false);
        }
        z() {
            if (this.d != null) {
                this.k = this.d.rootWrapper.getChildAt(0);
                this.k.setAttribute("tabIndex", "0");
                this.k.setStyleProperty("display", "flex");
                this.k.setStyleProperty("height", "100%");
                this.l = this.d.createElement("div");
                this.j = this.d.createElement("div");
                this.j.setRawStyleProperty("flex-grow", "1");
                this.g = this.d.createElement("div");
                this.g.setAttribute("aria-hidden", "true");
                this.f = this.d.createElement("div");
                this.i = this.d.createElement("div");
                this.i.setAttribute("aria-hidden", "true");
                this.h = this.d.createElement("div");
                this.b.cd();
                this.j.getChildAt(0).setAttribute("aria-expanded", "fasle");
                this.j.getChildAt(0).setAttribute("aria-invalid", "false");
                this.f.setStyleProperty("height", "16px");
                this.f.setStyleProperty("width", "16px");
                this.h.setStyleProperty("height", "16px");
                this.h.setStyleProperty("width", "16px");
                this.f.listen("click", runOn(this, this.y));
                this.h.listen("click", runOn(this, this.ac));
            }
        }
        aj(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.k);
                a.provideContainer(b);
                let c = this.d.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        al(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.l);
                a.provideContainer(b);
                let c = this.d.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        ak(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.j);
                a.provideContainer(b);
                let c = this.d.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        an(a, b) {
            if (this.d != null) {
                let c = this.d.getSubRenderer(b);
                a.provideContainer(c);
                let d = this.d.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        ai(a, b) {
            if (this.d != null) {
                let c = this.d.getSubRenderer(b);
                a.provideContainer(c);
                let d = this.d.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        u() {
            return this.l;
        }
        t() {
            return this.j;
        }
        q() {
            return this.g;
        }
        p() {
            return this.f;
        }
        s() {
            return this.i;
        }
        r() {
            return this.h;
        }
        ap(a) {
            if (this.j != null) {
                if (a) {
                    this.j.getChildAt(0).setAttribute("aria-expanded", "true");
                }
                else {
                    this.j.getChildAt(0).setAttribute("aria-expanded", "false");
                }
            }
        }
        aq(a) {
            if (a != null && a != "") {
                this.j.getChildAt(0).setAttribute("aria-label", a);
            }
            else {
                this.j.getChildAt(0).setAttribute("aria-label", "Select a date");
            }
        }
        ao() {
            if (this.f != null) {
                if (this.b.as == true) {
                    this.f.show();
                }
                else {
                    this.f.hide();
                }
            }
        }
        ad() {
            if (this.f != null) {
                this.f.hide();
            }
        }
        aa() {
            if (this.d != null) {
                this.m = this.d.rootWrapper.getChildAt(1);
                this.e = this.d.createElement("div");
                this.e.setStyleProperty("width", "100%");
                this.e.setStyleProperty("height", "100%");
                this.e.setStyleProperty("display", "flex");
                this.b.ce();
                this.e.parent().setStyleProperty("height", "100%");
                if (this.b.au == true) {
                    this.e.parent().parent().setStyleProperty("max-width", "245px");
                }
                else {
                    this.e.parent().parent().setStyleProperty("max-width", "232px");
                }
            }
        }
        am(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.m);
                a.provideRenderer(b);
                let c = b.getExternal(a, b.rootWrapper, b.getExternal(this.b, null, null));
            }
        }
        ah(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.e);
                a.provideContainer(b);
                let c = this.d.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        o() {
            return this.e;
        }
        y(a) {
            this.b.cb();
            if (this.f != null) {
                this.f.hide();
            }
        }
        ac(a) {
            a.stopPropagation();
            this.b.cj();
        }
        x(a) {
            let b = a.which;
            if (b == 27) {
                this.b.cc();
            }
        }
        v(a) {
            this.b.focus();
            let b = (a.originalEvent.relatedTarget);
            if (!this.c(b)) {
                this.b.cp();
            }
        }
        w(a) {
            let b = (a.originalEvent.relatedTarget);
            if (!this.c(b)) {
                this.b.ci();
                this.b.cq();
            }
        }
        ab(a) {
            let b = a.target;
            if (!this.c(b)) {
                this.b.cc();
            }
        }
        ar() {
            if (this.d != null) {
                let a = this.d.rootWrapper.getNativeElement();
                let b = a.getBoundingClientRect();
                ;
                return b;
            }
            return null;
        }
        a() {
            let a = (window.innerWidth);
            let b = (window.innerHeight);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        c(a) {
            if (null == a) {
                return false;
            }
            let b = this.j.getNativeElement();
            let c = this.e.getNativeElement();
            return b.contains(a) || c.contains(a);
        }
        ae() {
        }
    }
    DatePickerView.$t = /*@__PURE__*/ markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
})();
/**
 * @hidden
 */
export let DatePicker = /*@__PURE__*/ (() => {
    class DatePicker extends Base {
        constructor() {
            super();
            this.h = null;
            this.u = null;
            this.q = null;
            this.o = null;
            this.r = null;
            this.m = null;
            this.n = null;
            this.c = null;
            this.a6 = "dd";
            this.ba = "mm";
            this.bd = "yyyy";
            this.a7 = "mdy";
            this.bc = "/";
            this.ah = false;
            this.ao = false;
            this.an = false;
            this.ax = dateMinValue();
            this.propertyChanged = null;
            this.selectedValueChanged = null;
            this.ae = null;
            this.az = dateMinValue();
            this.ay = dateMinValue();
            this.a9 = "";
            this.c9 = BrushUtil.g(255, 24, 29, 31);
            this.z = null;
            this.bb = "";
            this.aw = dateMinValue();
            this.av = dateMaxValue();
            this.x = 2;
            this.v = 1;
            this.aa = null;
            this.da = BrushUtil.g(255, 24, 29, 31);
            this.c8 = BrushUtil.g(255, 163, 172, 184);
            this.ak = true;
            this.al = false;
            this.ag = true;
            this.aj = true;
            this.i = 0;
            this.k = 0;
            this.am = false;
            this.a = new DateTimeValueFormatter();
            this.d = 0;
            this.a8 = null;
            this.ai = false;
            this.gotFocus = null;
            this.lostFocus = null;
            this.keyDown = null;
            this.changing = null;
            let a = new DatePickerView();
            a.b = this;
            this.h = a;
            this.h.ag();
            this.ca();
        }
        cv(a, b) {
            if (this.u != null) {
                this.ah = true;
                this.cc();
            }
            this.c3();
            if (this.selectedValueChanged != null) {
                this.selectedValueChanged(this, ((() => {
                    let $ret = new SelectedValueChangedEventArgs();
                    $ret.oldValue = a;
                    $ret.newValue = b;
                    return $ret;
                })()));
            }
            this.cz();
        }
        notifySizeChanged() {
            this.h.ae();
        }
        destroy() {
            if (this.c != null) {
                let a = this.c;
                a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.b9));
                let b = this.c;
                b.close = delegateRemove(b.close, runOn(this, this.b8));
            }
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.h.af(a);
        }
        get af() {
            if (this.ae == null) {
                this.ae = new SRProvider(this.h.d);
                this.ae.cb("Calendar");
            }
            return this.ae;
        }
        get value() {
            return this.az;
        }
        set value(a) {
            let b = this.az;
            this.ax = b;
            this.az = a;
            if (+b != +(this.az)) {
                this.cu("Value", b, this.az);
            }
        }
        get a2() {
            return this.ay;
        }
        set a2(a) {
            let b = this.ay;
            this.ay = a;
            if (+b != +(this.ay)) {
                this.cu("Today", b, this.ay);
            }
        }
        get bs() {
            return this.a9;
        }
        set bs(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.cu("Label", b, this.a9);
            }
        }
        get dc() {
            return this.c9;
        }
        set dc(a) {
            let b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.cu("LabelTextColor", b, a);
            }
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.cu("LabelTextStyle", b, this.z);
            }
        }
        get bz() {
            return this.bb;
        }
        set bz(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.cu("Placeholder", b, this.bb);
            }
        }
        get a1() {
            return this.aw;
        }
        set a1(a) {
            let b = this.aw;
            this.aw = a;
            if (+b != +(this.aw)) {
                this.cu("MinDate", b, this.aw);
            }
        }
        get a0() {
            return this.av;
        }
        set a0(a) {
            let b = this.av;
            this.av = a;
            if (+b != +(this.av)) {
                this.cu("MaxDate", b, this.av);
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.cu("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.x));
            }
        }
        get w() {
            return this.v;
        }
        set w(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.cu("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.v));
            }
        }
        get ad() {
            return this.aa;
        }
        set ad(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.cu("TextStyle", b, this.aa);
            }
        }
        get dd() {
            return this.da;
        }
        set dd(a) {
            let b = this.da;
            this.da = a;
            if (b != this.da) {
                this.cu("TextColor", b, this.da);
            }
        }
        get db() {
            return this.c8;
        }
        set db(a) {
            let b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.cu("IconColor", b, this.c8);
            }
        }
        get as() {
            return this.ak;
        }
        set as(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.cu("ShowClearButton", b, this.ak);
            }
        }
        get at() {
            return this.al;
        }
        set at(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.cu("ShowTodayButton", b, this.al);
            }
        }
        get ap() {
            return this.ag;
        }
        set ap(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.cu("AllowTextInput", b, this.ag);
            }
        }
        get ar() {
            return this.aj;
        }
        set ar(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.cu("OpenOnFocus", b, this.aj);
            }
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.cu("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.i));
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.cu("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.k));
            }
        }
        get au() {
            return this.am;
        }
        set au(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.cu("ShowWeekNumbers", b, this.am);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (this.d != b) {
                this.cu("DateFormat", enumGetBox(DateFormats_$type, b), enumGetBox(DateFormats_$type, this.d));
            }
        }
        get bo() {
            return this.a8;
        }
        set bo(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.cu("FormatString", b, this.a8);
            }
        }
        get aq() {
            return this.ai;
        }
        set aq(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.cu("IsDisabled", b, this.ai);
            }
        }
        cu(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cx(a, b, c);
        }
        cx(a, b, c) {
            switch (a) {
                case "Density":
                    this.c0();
                    break;
                case "BaseTheme":
                    this.c1();
                    break;
                case "Value":
                    if (+(this.value) != +(dateMinValue())) {
                        if (dateGetDate(this.value) < dateGetDate(this.a1) || dateGetDate(this.value) > dateGetDate(this.a0)) {
                            this.value = this.ax;
                        }
                    }
                    this.cv(this.ax, this.value);
                    this.ax = this.value;
                    if (this.c != null) {
                        this.c.value = this.value;
                    }
                    break;
                case "Label":
                    if (this.r != null) {
                        this.r.text = this.bs;
                        if (this.bs != null && this.bs != "") {
                            if (!this.q.inputs.contains(this.r)) {
                                this.q.inputs.insert(0, this.r);
                            }
                        }
                        else {
                            if (this.q.inputs.contains(this.r)) {
                                this.q.inputs.remove(this.r);
                            }
                        }
                    }
                    break;
                case "Placeholder":
                    if (this.o != null) {
                        this.o.cb = this.bz;
                        this.h.aq(this.bz);
                    }
                    break;
                case "Today":
                    if (this.c != null) {
                        this.c.av = this.a2;
                    }
                    break;
                case "MaxDate":
                    if (this.c != null) {
                        let d = Base.compareSimple(this.a1, this.a0);
                        if (d >= 0) {
                            this.a0 = dateMaxValue();
                        }
                        this.c.at = this.av;
                    }
                    if (dateGetDate(this.value) > dateGetDate(this.a0)) {
                        this.ax = dateMinValue();
                        this.value = dateMinValue();
                    }
                    break;
                case "MinDate":
                    if (this.c != null) {
                        this.c.au = this.aw;
                        let e = Base.compareSimple(this.a1, this.a0);
                        if (e >= 0) {
                            this.ax = dateMaxValue();
                            this.c.at = this.a0;
                        }
                    }
                    if (dateGetDate(this.value) < dateGetDate(this.a1)) {
                        this.ax = dateMinValue();
                        this.value = dateMinValue();
                    }
                    break;
                case "TextStyle":
                    this.c4();
                    break;
                case "ShowClearButton":
                    if (this.o != null) {
                        if (this.o.cj != "") {
                            this.h.ao();
                        }
                    }
                    break;
                case "LabelTextColor":
                case "LabelTextStyle":
                case "TextColor":
                case "IconColor":
                    this.c5();
                    break;
                case "ShowTodayButton":
                    if (this.c != null) {
                        this.c.ae = this.at;
                    }
                    break;
                case "AllowTextInput":
                    if (this.o != null) {
                        this.o.disabled = !this.ap;
                    }
                    break;
                case "OpenOnFocus": break;
                case "DateFormat":
                    this.a.k(this.e);
                    this.c3();
                    break;
                case "FormatString":
                    this.ca();
                    this.c3();
                    break;
                case "FirstDayOfWeek":
                    if (this.c != null) {
                        this.c.l = this.j;
                    }
                    break;
                case "ShowWeekNumbers":
                    if (this.c != null) {
                        this.c.af = this.au;
                    }
                    break;
                case "FirstWeekOfYear":
                    if (this.c != null) {
                        this.c.o = this.l;
                    }
                    break;
                case "IsDisabled":
                    {
                        if (this.q != null) {
                            this.q.disabled = this.aq;
                        }
                        if (this.o != null) {
                            this.o.disabled = this.aq;
                        }
                    }
                    break;
            }
        }
        ca() {
            let a = '/';
            let b = this.bo != null ? this.bo.toLowerCase() : this.a.j();
            if (stringContains(b, "/")) {
                a = '/';
            }
            else if (stringContains(b, "-")) {
                a = '-';
            }
            else if (stringContains(b, " ")) {
                a = ' ';
            }
            else if (stringContains(b, ".")) {
                a = '.';
            }
            else if (stringContains(b, ",")) {
                a = ',';
            }
            this.bc = a.toString();
            let c = b.split(a);
            if (c.length == 3) {
                let d = "";
                for (let e = 0; e < 3; e++) {
                    if (stringContains(c[e], "d")) {
                        d += "d";
                        switch (c[e]) {
                            case "d":
                                this.a6 = c[e];
                                break;
                            case "dd":
                                this.a6 = c[e];
                                break;
                            case "ddd":
                                this.a6 = c[e];
                                break;
                            case "dddd":
                                this.a6 = c[e];
                                break;
                            default:
                                this.a6 = "dd";
                                break;
                        }
                    }
                    else if (stringContains(c[e], "m")) {
                        d += "m";
                        switch (c[e]) {
                            case "m":
                                this.ba = c[e];
                                break;
                            case "mm":
                                this.ba = c[e];
                                break;
                            case "mmm":
                                this.ba = c[e];
                                break;
                            case "mmmm":
                                this.ba = c[e];
                                break;
                            default:
                                this.ba = "mm";
                                break;
                        }
                        this.ba = c[e];
                    }
                    else if (stringContains(c[e], "y")) {
                        d += "y";
                        switch (c[e]) {
                            case "yy":
                                this.bd = c[e];
                                break;
                            case "yyyy":
                                this.bd = c[e];
                                break;
                            default:
                                this.bd = "yyyy";
                                break;
                        }
                    }
                }
                if (d == "dmy" || d == "mdy" || d == "ymd") {
                    this.a7 = d;
                }
                else {
                    this.a7 = "mdy";
                }
            }
        }
        c5() {
            if (this.o != null) {
                this.o.dy = this.dd;
            }
            if (this.m != null) {
                this.m.fill = this.db;
            }
            if (this.n != null) {
                this.n.fill = this.db;
            }
            if (this.r != null) {
                this.r.df = this.dc;
                this.r.y = this.ac;
            }
        }
        c2() {
            if (this.q != null) {
            }
        }
        c4() {
            if (this.aa != null) {
                this.o.ac = this.aa;
            }
        }
        cd() {
            this.q = new XInputGroup();
            this.h.aj(this.q);
            this.q.d = 0;
            this.q.j = this.w;
            this.q.n = this.y;
            this.r = new XLabel();
            this.h.al(this.r);
            this.r.df = this.dc;
            this.r.y = this.ac;
            this.q.appendContentChild(this.h.u());
            if (this.bs != null && this.bs != "") {
                this.r.text = this.bs;
                this.q.inputs.add(this.r);
            }
            this.o = new XInput();
            this.h.ak(this.o);
            this.o.b3 = "text";
            if (this.aa != null) {
                this.o.ac = this.aa;
            }
            this.o.disabled = !this.ap;
            this.o.dy = this.dd;
            this.q.appendContentChild(this.h.t());
            this.q.inputs.add(this.o);
            this.o.cb = this.bz;
            this.h.aq(this.bz);
            let a = this.o;
            a.change = delegateCombine(a.change, runOn(this, this.ck));
            let b = this.o;
            b.changing = delegateCombine(b.changing, runOn(this, this.cl));
            let c = this.o;
            c.keyDown = delegateCombine(c.keyDown, runOn(this, this.cm));
            let d = new XSuffix();
            this.h.an(d, this.h.q());
            this.m = new XIcon();
            this.h.ai(this.m, this.h.p());
            this.m.svgPath = DatePicker.bh;
            this.m.fill = this.db;
            d.appendContentChild(this.h.p());
            this.q.appendContentChild(this.h.q());
            this.q.inputs.add(d);
            this.c3();
            let e = new XSuffix();
            this.h.an(e, this.h.s());
            this.n = new XIcon();
            this.h.ai(this.n, this.h.r());
            this.n.svgPath = DatePicker.bg;
            this.n.fill = this.db;
            e.appendContentChild(this.h.r());
            this.q.appendContentChild(this.h.s());
            this.q.inputs.add(e);
        }
        cm(a, b) {
            this.cs(b);
            if (b.defaultPrevented) {
                return;
            }
            let c = b.keyCode;
            let d = b.modifiers;
            switch (c) {
                case 9:
                    this.an = true;
                    if (!this.ao) {
                        this.c7(this.o.cj);
                    }
                    this.ah = true;
                    this.cc();
                    this.an = false;
                    break;
                case 13:
                    this.an = true;
                    if (!this.ao) {
                        this.c7(this.o.cj);
                    }
                    this.ah = true;
                    this.cc();
                    this.an = false;
                    break;
                case 40:
                    if (d == 1) {
                        this.cw();
                        this.ch();
                    }
                    break;
                case 38:
                    if (d == 1) {
                        this.cc();
                    }
                    break;
            }
        }
        cl(a, b) {
            this.co(b);
            if (b.value.length > 0) {
                this.h.ao();
            }
            else {
                this.h.ad();
            }
        }
        ck(a, b) {
            this.ao = true;
            this.c7(b.value);
            this.ao = false;
        }
        c7(a) {
            let b = ['/', '-', ' ', '.', ','];
            let c = stringSplit(a, b, 1);
            let d = 0;
            let e = 0;
            let f = 0;
            let g = true;
            if (c.length == 3) {
                if (c[0].length == 0 || c[1].length == 0 || c[2].length == 0) {
                    g = false;
                }
                if (this.a7 == "dmy") {
                    d = parseInt(c[0]);
                    e = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.a7 == "mdy") {
                    e = parseInt(c[0]);
                    d = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.a7 == "ymd") {
                    f = parseInt(c[0]);
                    e = parseInt(c[1]);
                    d = parseInt(c[2]);
                }
                if (isNaN_(d) || isNaN_(f)) {
                    g = false;
                }
                if (f < 50) {
                    f = f + 2000;
                }
                if (isNaN_(e)) {
                    let h = "";
                    if (this.a7 == "dmy") {
                        h = c[1].toLowerCase();
                    }
                    else if (this.a7 == "mdy") {
                        h = c[0].toLowerCase();
                    }
                    else if (this.a7 == "ymd") {
                        h = c[1].toLowerCase();
                    }
                    let i = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full").toLowerCase() : "january";
                    let j = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short").toLowerCase() : "jan";
                    let k = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full").toLowerCase() : "february";
                    let l = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short").toLowerCase() : "feb";
                    let m = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full").toLowerCase() : "march";
                    let n = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short").toLowerCase() : "mar";
                    let o = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full").toLowerCase() : "april";
                    let p = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short").toLowerCase() : "apr";
                    let q = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full").toLowerCase() : "may";
                    let r = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short").toLowerCase() : "may";
                    let s = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full").toLowerCase() : "june";
                    let t = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short").toLowerCase() : "jun";
                    let u = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full").toLowerCase() : "july";
                    let v = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short").toLowerCase() : "jul";
                    let w = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full").toLowerCase() : "august";
                    let x = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short").toLowerCase() : "aug";
                    let y = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full").toLowerCase() : "september";
                    let z = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short").toLowerCase() : "sep";
                    let aa = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full").toLowerCase() : "october";
                    let ab = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short").toLowerCase() : "oct";
                    let ac = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full").toLowerCase() : "november";
                    let ad = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short").toLowerCase() : "nov";
                    let ae = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full").toLowerCase() : "december";
                    let af = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short").toLowerCase() : "dec";
                    if (h == i || h == j) {
                        e = 1;
                    }
                    else if (h == k || h == l) {
                        e = 2;
                    }
                    else if (h == m || h == n) {
                        e = 3;
                    }
                    else if (h == o || h == p) {
                        e = 4;
                    }
                    else if (h == q || h == r) {
                        e = 5;
                    }
                    else if (h == s || h == t) {
                        e = 6;
                    }
                    else if (h == u || h == v) {
                        e = 7;
                    }
                    else if (h == w || h == x) {
                        e = 8;
                    }
                    else if (h == y || h == z) {
                        e = 9;
                    }
                    else if (h == aa || h == ab) {
                        e = 10;
                    }
                    else if (h == ac || h == ad) {
                        e = 11;
                    }
                    else if (h == ae || h == af) {
                        e = 12;
                    }
                    else {
                        g = false;
                    }
                }
                if (e > 12 || e < 1) {
                    g = false;
                }
            }
            else {
                g = false;
            }
            if (g) {
                let ag = dateFromValues(f, e, d, 0, 0, 0, 0);
                let ah = Base.compareSimple(ag, this.a1);
                let ai = Base.compareSimple(ag, this.a0);
                if (ah < 0 || ai > 0) {
                    this.c3();
                }
                else {
                    this.c6(ag);
                    this.h.ao();
                }
            }
            else {
                if (stringIsNullOrEmpty(a)) {
                    this.cb();
                }
                else {
                    this.c3();
                }
            }
        }
        c6(a) {
            let b = this.value;
            this.value = a;
        }
        c3() {
            if (this.o != null) {
                if (+(this.az) != +(dateMinValue())) {
                    let a = "";
                    if (this.bo == null) {
                        a = this.a.i(this.value);
                    }
                    else {
                        let b = this.value.getDate().toString();
                        let c = b;
                        if (this.a6 == "dd") {
                            if (this.value.getDate() < 10) {
                                b = "0" + b;
                            }
                        }
                        else if (this.a6 == "ddd") {
                            switch (this.value.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Short")) ? this.af.b1("Sunday_Short") : "Sun";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Short")) ? this.af.b1("Monday_Short") : "Mon";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Short")) ? this.af.b1("Tuesday_Short") : "Tue";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Short")) ? this.af.b1("Wednesday_Short") : "Wed";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Short")) ? this.af.b1("Thursday_Short") : "Thu";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Short")) ? this.af.b1("Friday_Short") : "Fri";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Short")) ? this.af.b1("Saturday_Short") : "Sat";
                                    break;
                            }
                        }
                        else if (this.a6 == "dddd") {
                            switch (this.value.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Full")) ? this.af.b1("Sunday_Full") : "Sunday";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Full")) ? this.af.b1("Monday_Full") : "Monday";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Full")) ? this.af.b1("Tuesday_Full") : "Tuesday";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Full")) ? this.af.b1("Wednesday_Full") : "Wednesday";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Full")) ? this.af.b1("Thursday_Full") : "Thursday";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Full")) ? this.af.b1("Friday_Full") : "Friday";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Full")) ? this.af.b1("Saturday_Full") : "Saturday";
                                    break;
                            }
                        }
                        let d = dateGetMonth(this.value).toString();
                        if (this.ba == "mm") {
                            if (dateGetMonth(this.value) < 10) {
                                d = "0" + d;
                            }
                        }
                        else if (this.ba == "mmm") {
                            switch (dateGetMonth(this.value)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short") : "Jan";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short") : "Feb";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short") : "Mar";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short") : "Apr";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short") : "Jun";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short") : "Jul";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short") : "Aug";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short") : "Sep";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short") : "Oct";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short") : "Nov";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short") : "Dec";
                                    break;
                            }
                        }
                        else if (this.ba == "mmmm") {
                            switch (dateGetMonth(this.value)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full") : "January";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full") : "February";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full") : "March";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full") : "April";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full") : "June";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full") : "July";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full") : "August";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full") : "September";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full") : "October";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full") : "November";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full") : "December";
                                    break;
                            }
                        }
                        let e = this.value.getFullYear().toString();
                        if (this.bd == "yy") {
                            e = e.substr(2);
                        }
                        if (this.a7 == "dmy") {
                            if (this.a6 == "ddd" || this.a6 == "dddd") {
                                a = b + this.bc + d + " " + c + this.bc + e;
                            }
                            else {
                                a = b + this.bc + d + this.bc + e;
                            }
                        }
                        else if (this.a7 == "mdy") {
                            if (this.a6 == "ddd" || this.a6 == "dddd") {
                                a = d + " " + c + this.bc + b + this.bc + e;
                            }
                            else {
                                a = d + this.bc + b + this.bc + e;
                            }
                        }
                        else if (this.a7 == "ymd") {
                            if (this.a6 == "ddd" || this.a6 == "dddd") {
                                a = e + this.bc + d + " " + c + this.bc + b;
                            }
                            else {
                                a = e + this.bc + d + this.bc + b;
                            }
                        }
                    }
                    this.o.cj = a;
                    this.h.ao();
                }
                else {
                    this.o.cj = "";
                    this.h.ad();
                }
            }
        }
        cb() {
            if (this.o != null) {
                this.o.cj = "";
            }
            this.value = dateMinValue();
            this.c.ch();
        }
        ce() {
            this.u = new Popup();
            this.h.am(this.u);
            this.c = new XCalendar();
            this.h.ah(this.c);
            if (+(this.a1) != +(dateMinValue())) {
                this.c.au = this.a1;
            }
            if (+(this.a0) != +(dateMaxValue())) {
                this.c.at = this.a0;
            }
            if (+(this.a2) != +(dateMinValue())) {
                this.c.av = this.a2;
            }
            this.c.ae = this.at;
            this.c.l = this.j;
            this.c.af = this.au;
            this.c.o = this.l;
            let a = this.c;
            a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.b9));
            let b = this.c;
            b.close = delegateCombine(b.close, runOn(this, this.b8));
            this.u.appendPopupContent(this.h.o());
        }
        b9(a, b) {
            this.value = b.newValue;
        }
        b8(a) {
            if (this.u.t) {
                this.ah = true;
                this.cc();
            }
        }
        cj() {
            if (this.ah == false) {
                if (this.u.t) {
                    this.cc();
                }
                else {
                    this.cw();
                }
            }
            else {
                this.ah = false;
            }
        }
        cw() {
            if (this.aq) {
                return;
            }
            if (this.u != null) {
                let a = this.h.ar();
                let b = new Rect(0, a.left + window.pageXOffset, a.top + window.pageYOffset, a.width, a.height);
                let c = this.h.a()[1];
                let d = 240;
                if (this.at == true) {
                    d = 270;
                }
                let e = a.bottom + d;
                if (c < e) {
                    let f = a.top - d;
                    if (f < 0) {
                        this.u.showRelativeToExclusionRect(b, 1, 0);
                    }
                    else {
                        this.u.showRelativeToExclusionRect(b, 2, 0);
                    }
                }
                else {
                    this.u.showRelativeToExclusionRect(b, 1, 0);
                }
                this.h.ap(true);
            }
        }
        cc() {
            if (this.u != null) {
                window.setTimeout(() => this.u.ao(), 0);
            }
            if (this.c != null) {
                this.c.cy();
            }
            this.h.ap(false);
            this.ah = false;
        }
        focus(a = false) {
            if (this.o != null) {
                this.o.focus(a);
            }
            if (!this.u.t && this.ar == true) {
                if (this.ah == false) {
                    if (this.ap == false) {
                        this.cw();
                        this.ah = true;
                        window.setTimeout(() => this.ch(), 0);
                    }
                    else {
                        if (this.ar == true && this.an == false) {
                            this.cw();
                            this.ah = true;
                            window.setTimeout(() => this.ch(), 0);
                        }
                    }
                }
                else {
                    this.ah = false;
                }
            }
        }
        ci() {
            this.ah = false;
        }
        cz() {
            if (this.o != null) {
                this.o.dg();
            }
        }
        ch() {
            this.c.cq();
        }
        cp() {
            let a = new GotFocusEventArgs();
            this.cr(a);
        }
        cq() {
            let a = new LostFocusEventArgs();
            this.ct(a);
        }
        c1() {
        }
        c0() {
        }
        a5() {
            return this.b();
        }
        bl() {
            let a = this.b();
            return a.g();
        }
        b() {
            let a = new DatePickerVisualModelExport();
            a.e = this.y;
            a.d = this.w;
            a.c = this.u.ab();
            a.b = this.q.ia();
            a.a = this.c.bj();
            if (this.ad != null) {
                let b = this.ad;
                if (this.h != null && b.n == null) {
                    let c = this.h.d;
                    let d = FontUtil.getFontInfoFromString(c, b.fontString);
                    b.n = d.n;
                    b.d = d.d;
                    b.o = d.o;
                    b.q = d.q;
                    b.r = d.r;
                    b.s = d.s;
                }
                if (b.n != null) {
                    a.h = b.n;
                }
                if (!isNaN_(b.d)) {
                    a.f = b.d;
                }
                if (b.s != null) {
                    a.l = b.s;
                }
                if (b.q != null) {
                    a.j = b.q;
                }
                if (b.o != null) {
                    a.i = b.q;
                }
            }
            return a;
        }
        cr(a) {
            if (null != this.gotFocus) {
                this.gotFocus(this, a);
            }
        }
        ct(a) {
            if (null != this.lostFocus) {
                this.lostFocus(this, a);
            }
        }
        cs(a) {
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        co(a) {
            if (null != this.changing) {
                this.changing(this, a);
            }
        }
    }
    DatePicker.$t = /*@__PURE__*/ markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.bg = "M20 3h-1V1h-2v2H7V1H5v2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 18H4V8h16v13z";
    DatePicker.bh = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    DatePicker.ab = null;
    return DatePicker;
})();
