import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { IIcon } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
/**
 * @hidden
 */
export declare class IconView extends Base {
    static $t: Type;
    constructor();
    b: XIcon;
    u(): void;
    e(): boolean;
    h: DomRenderer;
    private c;
    private g;
    get k(): any;
    get l(): any;
    get f(): boolean;
    s(a: DomRenderer): void;
    private m;
    x(a: string): void;
    w(): void;
    private n;
    v(): void;
    private o;
    private p;
    private d;
    private i;
    private j;
    q(): void;
    t(): void;
    y(a: FontInfo): void;
    a(): number[];
    private r;
}
/**
 * @hidden
 */
export declare class XIcon extends Base implements INotifyPropertyChanged, IIcon {
    static $t: Type;
    constructor();
    private _view;
    get view(): IconView;
    set view(a: IconView);
    destroy(): void;
    protected bc(a: string, b: any, c: any): void;
    protected be(a: string, b: any, c: any): void;
    private bi;
    protected get j(): boolean;
    private bh;
    private bg;
    static bz: Brush;
    static b3: Brush;
    static b2: Brush;
    static b0: Brush;
    static b1: Brush;
    static v: number;
    static u: number;
    private bj;
    get bu(): Brush;
    set bu(a: Brush);
    private bn;
    get by(): Brush;
    set by(a: Brush);
    private bk;
    get bv(): Brush;
    set bv(a: Brush);
    private bl;
    get bw(): Brush;
    set bw(a: Brush);
    private bm;
    get bx(): Brush;
    set bx(a: Brush);
    private n;
    get s(): number;
    set s(a: number);
    private o;
    get t(): number;
    set t(a: number);
    private bo;
    get fill(): Brush;
    set fill(a: Brush);
    private bt;
    get b8(): Brush;
    set b8(a: Brush);
    private af;
    get svgPath(): string;
    set svgPath(a: string);
    private bp;
    get b4(): Brush;
    set b4(a: Brush);
    private bq;
    get b5(): Brush;
    set b5(a: Brush);
    private bs;
    get b7(): Brush;
    set b7(a: Brush);
    private p;
    get w(): number;
    set w(a: number);
    private r;
    get y(): number;
    set y(a: number);
    ba(): void;
    bb(): void;
    private d;
    get e(): FontInfo;
    set e(a: FontInfo);
    private br;
    get b6(): Brush;
    set b6(a: Brush);
    private static ab;
    private ae;
    get av(): string;
    set av(a: string);
    private z;
    private f;
    get i(): boolean;
    get aa(): number;
    set aa(a: number);
    private ad;
    get an(): string;
    set an(a: string);
    private h;
    get l(): boolean;
    set l(a: boolean);
    private g;
    get disabled(): boolean;
    set disabled(a: boolean);
    private q;
    get x(): number;
    set x(a: number);
    bd(): void;
    clicked: (sender: any, args: IconClickedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    a8(): void;
    protected m(): boolean;
    ac(): any;
    ap(): string;
    a(): IconVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
