/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, Delegate_$type, fromEnum, runOn, markType, Point_$type, typeGetValue, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, EventArgs, delegateCombine, fromEn, toNullable, Number_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { SuffixShiftType_$type } from "./SuffixShiftType";
import { PrefixShiftType_$type } from "./PrefixShiftType";
import { LabelShiftType_$type } from "./LabelShiftType";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
import { InputShiftType_$type } from "./InputShiftType";
import { SuffixVisualModelExport } from "./SuffixVisualModelExport";
import { PrefixVisualModelExport } from "./PrefixVisualModelExport";
import { InputGroupDisplayType_$type } from "./InputGroupDisplayType";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { InputGroupVisualModelExport } from "./InputGroupVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { LabelVisualModelExport } from "./LabelVisualModelExport";
import { InputVisualModelExport } from "./InputVisualModelExport";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { MaskParsingService } from "./MaskParsingService";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { MaskOptions } from "./MaskOptions";
/**
 * @hidden
 */
export let InputGroupView = /*@__PURE__*/ (() => {
    class InputGroupView extends Base {
        constructor() {
            super();
            this.d = null;
            this.l = null;
            this.e = null;
            this.i = new List$1(Delegate_$type, 0);
            this.z = null;
            this.f = true;
            this.n = null;
            this.o = null;
            this.p = null;
            this.t = null;
            this.r = null;
            this.q = null;
            this.m = null;
        }
        ak() {
        }
        ac(a) {
            if (typeCast(XLabel.$, a) !== null) {
                a.bc = "flex-start";
            }
        }
        ae(a) {
        }
        ad() {
        }
        g() {
            return true;
        }
        get w() {
            return this.n;
        }
        get as() {
            return null;
        }
        get h() {
            return true;
        }
        ah(a) {
            if (a == null) {
                for (let b of fromEnum(this.i)) {
                    b();
                }
                this.i.clear();
            }
            this.l = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            a.rootWrapper.setStyleProperty("box-sizing", "border-box");
            a.rootWrapper.setStyleProperty("border-width", "0px");
            a.rootWrapper.setStyleProperty("border-style", "solid");
            let c = this.v;
            this.i.add(c.listen("focusin", runOn(this, this.aj)));
            this.i.add(c.listen("focusout", runOn(this, this.am)));
            let d = this.l.createElement("div");
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("border-style", "solid");
            d.setStyleProperty("box-sizing", "border-box");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            this.l.append(d);
            this.m = d;
            let e = this.l.createElement("div");
            e.addClass("ig-input-content");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("position", "relative");
            e.setStyleProperty("display", "flex");
            e.setStyleProperty("flex-direction", "row");
            e.setStyleProperty("flex-wrap", "no-wrap");
            e.setStyleProperty("flex-flow", "row nowrap");
            e.setStyleProperty("flex-grow", "1");
            e.setStyleProperty("align-items", "center");
            e.setStyleProperty("padding-top", "1.125rem");
            this.p = e;
            this.i.add(e.listen("click", runOn(this, this.aa)));
            this.l.append(e);
            this.l.getPortal(e, "ChildContent", (f) => {
                let comp_ = f.componentRef;
                this.t = comp_;
                this.p.setStyleProperty("flex-direction", "row");
            }, true);
            let f = this.l.createElement("div");
            f.setStyleProperty("position", "absolute");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("background-color", "rgba(0, 0, 0, 0.54)");
            f.setStyleProperty("height", "1px");
            f.setStyleProperty("pointer-events", "none");
            f.setStyleProperty("left", "0px");
            f.setStyleProperty("bottom", "1px");
            f.setStyleProperty("overflow", "visible");
            let g = this.l.createElement("span");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "2px");
            g.setStyleProperty("display", "block");
            g.setStyleProperty("pointer-events", "none");
            NativeUI.ab(g, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.5;
                $ret.m = 1;
                return $ret;
            })()));
            g.setStyleProperty("opacity", "0");
            this.r = g;
            f.append(this.r);
            this.q = f;
            this.l.append(f);
            this.d.mf();
        }
        get s() {
            return this.p;
        }
        get v() {
            return this.l.rootWrapper;
        }
        get u() {
            return this.m;
        }
        get x() {
            return this.q;
        }
        get y() {
            return this.r;
        }
        aq(a) {
            if (this.z != a) {
                this.z = a;
                if (this.o != null) {
                    this.o.setAttribute("d", this.z);
                }
            }
        }
        ap() {
            switch (this.d.m) {
                case 1:
                    this.p.setStyleProperty("padding-top", "1.125rem");
                    break;
                case 2:
                    this.p.setStyleProperty("padding-top", ".94737rem");
                    break;
                case 3:
                    this.p.setStyleProperty("padding-top", ".81818rem");
                    break;
            }
        }
        aa(a) {
        }
        al() {
            if (this.g()) {
            }
        }
        j() {
            let a = this.l.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        ag() {
            this.f = true;
        }
        ai() {
            this.f = false;
            for (let a of fromEnum(this.i)) {
                a();
            }
            this.i.clear();
        }
        ar(a) {
            if (a != null) {
                this.l.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        k(a) {
            return a.view.i();
        }
        af() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.u, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.x, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.r, 0, null, a);
        }
        ao(a) {
        }
        ab(a) {
            this.p.append(a);
        }
        an(a) {
            this.p.removeChild(a);
        }
        aj(a) {
            this.d.mb();
        }
        am(a) {
            this.d.md();
        }
    }
    InputGroupView.$t = /*@__PURE__*/ markType(InputGroupView, 'InputGroupView');
    return InputGroupView;
})();
/**
 * @hidden
 */
export let SuffixView = /*@__PURE__*/ (() => {
    class SuffixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-suffix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.am();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.k == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.ab(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.aj();
        }
        j(a) {
            this.a.ak();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    SuffixView.$t = /*@__PURE__*/ markType(SuffixView, 'SuffixView');
    return SuffixView;
})();
/**
 * @hidden
 */
export let PrefixView = /*@__PURE__*/ (() => {
    class PrefixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-prefix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.am();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.k == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.ab(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.aj();
        }
        j(a) {
            this.a.ak();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    PrefixView.$t = /*@__PURE__*/ markType(PrefixView, 'PrefixView');
    return PrefixView;
})();
/**
 * @hidden
 */
export let LabelView = /*@__PURE__*/ (() => {
    class LabelView extends Base {
        constructor() {
            super();
            this.c = null;
            this.k = null;
            this.d = null;
            this.h = new List$1(Delegate_$type, 0);
            this.o = null;
            this.e = true;
            this.l = null;
            this.m = null;
        }
        ab() {
        }
        f() {
            return true;
        }
        get n() {
            return this.l;
        }
        get aj() {
            return null;
        }
        get g() {
            return true;
        }
        s() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.k.rootWrapper, 0, null, a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.k.rootWrapper, 0, null, a);
        }
        w(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
            }
            this.k = a;
            this.k.rootWrapper.setStyleProperty("display", "inline-block");
            this.k.rootWrapper.setStyleProperty("position", "relative");
            let c = this.k.createElement("label");
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("white-space", "nowrap");
            c.setStyleProperty("text-overflow", "ellipsis");
            c.setStyleProperty("line-height", "1");
            c.setStyleProperty("overflow", "hidden");
            c.setStyleProperty("height", "1.125rem");
            c.setStyleProperty("backface-visibility", "hidden");
            NativeUI.o(this.k.rootWrapper, this.c.cz);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.l = c;
            this.k.append(this.l);
            this.c.ch();
        }
        j() {
            return this.c.l == 0 ? (this.i() * 0.5) : 0;
        }
        af() {
            this.c.bi = "block";
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.c.l == 0 ? (this.i() * 0.5) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.ab(this.k.rootWrapper, a);
            this.l.setStyleProperty("height", "1.125rem");
            this.k.rootWrapper.setStyleProperty("position", "absolute");
            this.k.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        ag() {
            switch (this.c.s) {
                case 1:
                    this.k.rootWrapper.setStyleProperty("margin-top", "0px");
                    break;
                case 2:
                    this.k.rootWrapper.setStyleProperty("margin-top", "-.125rem");
                    break;
                case 3:
                    this.k.rootWrapper.setStyleProperty("margin-top", "-.25rem");
                    break;
            }
        }
        ae() {
            this.l.setText(this.c.text != null ? this.c.text : "");
        }
        ah(a) {
            if (this.o != a) {
                this.o = a;
                if (this.m != null) {
                    this.m.setAttribute("d", this.o);
                }
            }
        }
        y() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("display", this.c.bi);
                this.l.setStyleProperty("display", this.c.bi);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        t() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-items", this.c.ba);
                this.l.setStyleProperty("align-items", this.c.ba);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        u() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-self", this.c.bc);
                this.l.setStyleProperty("align-self", this.c.bc);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onAlignSelfChanged) {
                    ext_._onAlignSelfChanged();
                }
                ;
            }
        }
        z() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-direction", this.c.bl);
                this.l.setStyleProperty("flex-direction", this.c.bl);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        aa() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-grow", this.c.bn);
                this.l.setStyleProperty("flex-grow", this.c.bn);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        p(a) {
        }
        ac() {
            if (this.f()) {
            }
        }
        i() {
            let a = this.k.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        q(a) {
            this.c.ce();
        }
        r(a) {
            this.c.cf();
        }
        v() {
            this.e = true;
            this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.q)));
            this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.r)));
        }
        x() {
            this.e = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        ai(a) {
            if (a != null) {
                this.l.setStyleProperty("font", a.fontString);
            }
        }
        ad(a) {
            NativeUI.o(this.l, a);
        }
    }
    LabelView.$t = /*@__PURE__*/ markType(LabelView, 'LabelView');
    return LabelView;
})();
/**
 * @hidden
 */
export let InputView = /*@__PURE__*/ (() => {
    class InputView extends Base {
        constructor() {
            super();
            this.b = null;
            this.j = null;
            this.c = null;
            this.h = new List$1(Delegate_$type, 0);
            this.e = false;
            this.p = null;
            this.d = true;
            this.k = null;
            this.l = null;
            this.e = false;
        }
        ao() {
        }
        f() {
            return true;
        }
        get o() {
            return this.k;
        }
        get a4() {
            return null;
        }
        get g() {
            return true;
        }
        al(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
            }
            this.j = a;
            this.j.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.j.createElement("input");
            c.setAttribute("type", this.b.b3);
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("box-sizing", "border-box");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("border", "none");
            c.setStyleProperty("height", "2rem");
            c.setStyleProperty("line-height", "0");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("min-width", "0");
            c.setStyleProperty("overflow", "visible");
            c.setStyleProperty("background", "transparent");
            c.setStyleProperty("background-position-x", "initial");
            c.setStyleProperty("background-position-y", "initial");
            c.setStyleProperty("background-size", "initial");
            c.setStyleProperty("background-repeat-x", "initial");
            c.setStyleProperty("background-repeat-y", "initial");
            c.setStyleProperty("background-attachment", "initial");
            c.setStyleProperty("background-origin", "initial");
            c.setStyleProperty("background-color", "transparent");
            NativeUI.o(c, this.b.du);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("border-top", "0.1875rem solid transparent");
            c.setStyleProperty("padding-bottom", "0.1875rem");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.h.add(c.listen("change", runOn(this, this.v)));
            this.h.add(c.listen("input", runOn(this, this.w)));
            this.h.add(c.listen("focus", runOn(this, this.ab)));
            this.h.add(c.listen("blur", runOn(this, this.u)));
            this.h.add(c.listen("mouseenter", runOn(this, this.s)));
            this.h.add(c.listen("mouseleave", runOn(this, this.t)));
            this.h.add(c.listen("keydown", runOn(this, this.ac)));
            this.h.add(c.listen("keyup", runOn(this, this.ae)));
            this.h.add(c.listen("keypress", runOn(this, this.ad)));
            this.h.add(c.listen("paste", runOn(this, this.ah)));
            this.h.add(c.listen("dragenter", runOn(this, this.z)));
            this.h.add(c.listen("dragleave", runOn(this, this.aa)));
            this.h.add(c.listen("compositionstart", runOn(this, this.y)));
            this.h.add(c.listen("compositionend", runOn(this, this.x)));
            this.h.add(c.listen("mousedown", runOn(this, this.af)));
            this.h.add(c.listen("mouseup", runOn(this, this.ag)));
            this.k = c;
            this.j.append(this.k);
            this.b.dd();
        }
        av(a) {
            if (a) {
                this.k.setAttribute("readonly", a.toString());
            }
            else {
                this.k.getNativeElement().removeAttribute("readonly");
            }
        }
        au(a) {
            if (a) {
                this.k.setAttribute("disabled", "true");
            }
            else {
                this.k.getNativeElement().removeAttribute("disabled");
            }
        }
        y(a) {
            this.e = true;
            this.b.cv();
        }
        x(a) {
            this.e = false;
            this.b.cu();
        }
        as() {
            this.k.setAttribute("type", this.b.b3);
            if (this.b.b3 == "date") {
                this.k.setStyleProperty("line-height", "normal");
            }
            else {
                this.k.setStyleProperty("line-height", "0");
            }
        }
        aq() {
            this.k.setAttribute("placeholder", this.b.cb);
        }
        a0() {
            switch (this.b.w) {
                case 1:
                    this.k.setStyleProperty("height", "2rem");
                    this.k.setStyleProperty("font-size", "1rem");
                    break;
                case 2:
                    this.k.setStyleProperty("height", "1.68421rem");
                    this.k.setStyleProperty("font-size", "1rem");
                    break;
                case 3:
                    this.k.setStyleProperty("height", "1.45455rem");
                    this.k.setStyleProperty("font-size", ".95455rem");
                    break;
            }
        }
        az() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.b.n == 2 ? (this.i() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.ab(this.j.rootWrapper, a);
            this.j.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        i() {
            let a = this.j.rootWrapper.getStyleProperty("height");
            let b = parseFloat(stringReplace(a, "px", ""));
            return b;
        }
        at(a) {
            this.k.setProperty("value", a);
        }
        u(a) {
            this.b.cr();
        }
        ab(a) {
            this.b.cz();
        }
        af(a) {
            let b = this.a3(a);
            this.b.c5(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        ag(a) {
            let b = this.a3(a);
            this.b.c8(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        a3(a) {
            let b = new MouseButtonEventArgs();
            b.position = { $type: Point_$type, x: a.offsetX, y: a.offsetY };
            return b;
        }
        v(a) {
            this.b.cs();
        }
        w(a) {
            this.b.ct();
        }
        ac(a) {
            let b = new KeyEventArgs(0, a);
            this.b.c2(b);
        }
        ae(a) {
            let b = new KeyEventArgs(0, a);
            this.b.c4(b);
        }
        ad(a) {
            let b = new KeyEventArgs(0, a);
            this.b.c3(b);
        }
        ah(a) {
            this.b.c9();
        }
        z(a) {
            this.b.cx();
        }
        aa(a) {
            this.b.cy();
        }
        a1(a) {
            if (this.p != a) {
                this.p = a;
                if (this.l != null) {
                    this.l.setAttribute("d", this.p);
                }
            }
        }
        q() {
            return this.k.getProperty("value");
        }
        r(a) {
        }
        n() {
            let a = this.k.getProperty("selectionStart");
            return typeGetValue(a);
        }
        m() {
            let a = this.k.getProperty("selectionEnd");
            return typeGetValue(a);
        }
        ay(a) {
            this.k.setProperty("selectionStart", a);
        }
        aw(a) {
            this.k.setProperty("selectionEnd", a);
        }
        ap() {
            if (this.f()) {
            }
        }
        s(a) {
            this.b.c6();
        }
        t(a) {
            this.b.c7();
        }
        aj() {
            this.d = true;
            this.h.add(this.k.listen("change", runOn(this, this.v)));
            this.h.add(this.k.listen("input", runOn(this, this.w)));
            this.h.add(this.k.listen("focus", runOn(this, this.ab)));
            this.h.add(this.k.listen("blur", runOn(this, this.u)));
            this.h.add(this.k.listen("mouseenter", runOn(this, this.s)));
            this.h.add(this.k.listen("mouseleave", runOn(this, this.t)));
            this.h.add(this.k.listen("keydown", runOn(this, this.ac)));
            this.h.add(this.k.listen("paste", runOn(this, this.ah)));
            this.h.add(this.k.listen("dragenter", runOn(this, this.z)));
            this.h.add(this.k.listen("dragleave", runOn(this, this.aa)));
            this.h.add(this.k.listen("compositionstart", runOn(this, this.y)));
            this.h.add(this.k.listen("compositionend", runOn(this, this.x)));
            this.h.add(this.k.listen("mousedown", runOn(this, this.af)));
            this.h.add(this.k.listen("mouseup", runOn(this, this.ag)));
        }
        am() {
            this.d = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        a2(a) {
            if (a != null) {
                this.k.setStyleProperty("font", a.fontString);
            }
        }
        ak() {
            if (this.k != null) {
                let a = this.k.getNativeElement();
                a.blur();
            }
        }
        an(a) {
            if (this.k != null) {
                this.k.focus(a);
            }
        }
        ar() {
            if (this.k != null) {
                let nativeInput_ = this.k;
                nativeInput_.getNativeElement().select();
            }
        }
        ax(a, b) {
            if (this.k != null) {
                let c = this.k.getNativeElement();
                c.setSelectionRange(a, b);
            }
        }
        ai() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.j;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.j.rootWrapper, 0, null, a);
        }
    }
    InputView.$t = /*@__PURE__*/ markType(InputView, 'InputView');
    return InputView;
})();
/**
 * @hidden
 */
export let XInputGroupItem = /*@__PURE__*/ (() => {
    class XInputGroupItem extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = null;
            this.propertyChanged = null;
        }
        get e() {
            return this.c;
        }
        set e(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g("Name", b, a);
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g("InputGroup", b, a);
            }
        }
        g(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.h(a, b, c);
        }
        h(a, b, c) {
        }
    }
    XInputGroupItem.$t = /*@__PURE__*/ markType(XInputGroupItem, 'XInputGroupItem', Base.$, [INotifyPropertyChanged_$type]);
    return XInputGroupItem;
})();
/**
 * @hidden
 */
export let XSuffix = /*@__PURE__*/ (() => {
    class XSuffix extends XInputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.j = 0;
            this.v = "ig-suffix-" + XSuffix.s++;
            this.u = null;
            this.n = false;
            this.m = false;
            this.o = false;
            let a = new SuffixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get k() {
            return this.j;
        }
        set k(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("ShiftType", enumGetBox(SuffixShiftType_$type, b), enumGetBox(SuffixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.ai();
                    break;
                case "ShiftType":
                    this.al();
                    break;
            }
        }
        al() {
            this.view.q();
        }
        ai() {
            this.view.q();
        }
        ap() {
        }
        ao() {
        }
        aj() {
            this.q = true;
        }
        ak() {
            this.q = false;
        }
        get z() {
            return this.v;
        }
        set z(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("Id", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("AriaLabel", b, a);
            }
        }
        get q() {
            return this.n;
        }
        set q(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.m;
        }
        set disabled(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsDisabled", b, a);
            }
        }
        am() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        r() {
            return this.view.d();
        }
        t() {
            return this.i();
        }
        y() {
            let a = this.i();
            return a.e();
        }
        i() {
            let a = new SuffixVisualModelExport();
            a.a = this.k;
            a.c = this.q;
            a.b = this.disabled;
            a.d = this.e;
            return a;
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    XSuffix.$t = /*@__PURE__*/ markType(XSuffix, 'XSuffix', XInputGroupItem.$);
    XSuffix.s = 0;
    return XSuffix;
})();
/**
 * @hidden
 */
export let XPrefix = /*@__PURE__*/ (() => {
    class XPrefix extends XInputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.j = 0;
            this.v = "ig-prefix-" + XPrefix.s++;
            this.u = null;
            this.n = false;
            this.m = false;
            this.o = false;
            let a = new PrefixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get k() {
            return this.j;
        }
        set k(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("ShiftType", enumGetBox(PrefixShiftType_$type, b), enumGetBox(PrefixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.ai();
                    break;
                case "ShiftType":
                    this.al();
                    break;
            }
        }
        al() {
            this.view.q();
        }
        ai() {
            this.view.q();
        }
        ap() {
        }
        ao() {
        }
        aj() {
            this.q = true;
        }
        ak() {
            this.q = false;
        }
        get z() {
            return this.v;
        }
        set z(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("Id", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("AriaLabel", b, a);
            }
        }
        get q() {
            return this.n;
        }
        set q(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.m;
        }
        set disabled(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsDisabled", b, a);
            }
        }
        am() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        r() {
            return this.view.d();
        }
        t() {
            return this.i();
        }
        y() {
            let a = this.i();
            return a.e();
        }
        i() {
            let a = new PrefixVisualModelExport();
            a.a = this.k;
            a.c = this.q;
            a.b = this.disabled;
            a.d = this.e;
            return a;
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    XPrefix.$t = /*@__PURE__*/ markType(XPrefix, 'XPrefix', XInputGroupItem.$);
    XPrefix.s = 0;
    return XPrefix;
})();
/**
 * @hidden
 */
export let XInputGroup = /*@__PURE__*/ (() => {
    class XInputGroup extends Base {
        constructor() {
            super();
            this.c = 0;
            this.l = 1;
            this.k = 1;
            this.ad = false;
            this.h = 0;
            this._view = null;
            this.q = null;
            this.o = null;
            this.lostFocus = null;
            this.gotFocus = null;
            this.df = ThemeResolver.b(XInputGroup.i, XInputGroup.fu, XInputGroup.d1);
            this.e5 = ThemeResolver.b(XInputGroup.i, XInputGroup.f5, XInputGroup.ec);
            this.m7 = ThemeResolver.d(XInputGroup.i, XInputGroup.ng, XInputGroup.na);
            this.tn = ThemeResolver.f(XInputGroup.i, XInputGroup.tw, XInputGroup.tq);
            this.pg = ThemeResolver.e(XInputGroup.i, XInputGroup.re, XInputGroup.py);
            this.q1 = ThemeResolver.e(XInputGroup.i, XInputGroup.rv, XInputGroup.qf);
            this.q2 = ThemeResolver.e(XInputGroup.i, XInputGroup.rw, XInputGroup.qg);
            this.hb = ThemeResolver.b(XInputGroup.i, XInputGroup.gx, XInputGroup.e4);
            this.ha = ThemeResolver.b(XInputGroup.i, XInputGroup.gw, XInputGroup.e3);
            this.e9 = ThemeResolver.b(XInputGroup.i, XInputGroup.f9, XInputGroup.eg);
            this.sp = ThemeResolver.e(XInputGroup.i, XInputGroup.sf, XInputGroup.qz);
            this.sq = ThemeResolver.e(XInputGroup.i, XInputGroup.sg, XInputGroup.q0);
            this.q4 = ThemeResolver.e(XInputGroup.i, XInputGroup.ry, XInputGroup.qi);
            this.q3 = ThemeResolver.e(XInputGroup.i, XInputGroup.rx, XInputGroup.qh);
            this.g8 = ThemeResolver.b(XInputGroup.i, XInputGroup.gu, XInputGroup.e1);
            this.e8 = ThemeResolver.b(XInputGroup.i, XInputGroup.f8, XInputGroup.ef);
            this.e6 = ThemeResolver.b(XInputGroup.i, XInputGroup.f6, XInputGroup.ed);
            this.e7 = ThemeResolver.b(XInputGroup.i, XInputGroup.f7, XInputGroup.ee);
            this.g9 = ThemeResolver.b(XInputGroup.i, XInputGroup.gv, XInputGroup.e2);
            this.pf = ThemeResolver.e(XInputGroup.i, XInputGroup.rd, XInputGroup.px);
            this.fa = ThemeResolver.b(XInputGroup.i, XInputGroup.ga, XInputGroup.eh);
            this.fb = ThemeResolver.b(XInputGroup.i, XInputGroup.gb, XInputGroup.ei);
            this.nd = ThemeResolver.d(XInputGroup.i, XInputGroup.nh, XInputGroup.nb);
            this.tt = ThemeResolver.f(XInputGroup.i, XInputGroup.tx, XInputGroup.tr);
            this.q6 = ThemeResolver.e(XInputGroup.i, XInputGroup.r0, XInputGroup.qk);
            this.q7 = ThemeResolver.e(XInputGroup.i, XInputGroup.r1, XInputGroup.ql);
            this.q8 = ThemeResolver.e(XInputGroup.i, XInputGroup.r2, XInputGroup.qm);
            this.fj = ThemeResolver.b(XInputGroup.i, XInputGroup.gj, XInputGroup.eq);
            this.fi = ThemeResolver.b(XInputGroup.i, XInputGroup.gi, XInputGroup.ep);
            this.ff = ThemeResolver.b(XInputGroup.i, XInputGroup.gf, XInputGroup.em);
            this.rb = ThemeResolver.e(XInputGroup.i, XInputGroup.r5, XInputGroup.qp);
            this.rc = ThemeResolver.e(XInputGroup.i, XInputGroup.r6, XInputGroup.qq);
            this.ra = ThemeResolver.e(XInputGroup.i, XInputGroup.r4, XInputGroup.qo);
            this.q9 = ThemeResolver.e(XInputGroup.i, XInputGroup.r3, XInputGroup.qn);
            this.fg = ThemeResolver.b(XInputGroup.i, XInputGroup.gg, XInputGroup.en);
            this.fe = ThemeResolver.b(XInputGroup.i, XInputGroup.ge, XInputGroup.el);
            this.fc = ThemeResolver.b(XInputGroup.i, XInputGroup.gc, XInputGroup.ej);
            this.fd = ThemeResolver.b(XInputGroup.i, XInputGroup.gd, XInputGroup.ek);
            this.fh = ThemeResolver.b(XInputGroup.i, XInputGroup.gh, XInputGroup.eo);
            this.q5 = ThemeResolver.e(XInputGroup.i, XInputGroup.rz, XInputGroup.qj);
            this.dg = ThemeResolver.b(XInputGroup.i, XInputGroup.fv, XInputGroup.d2);
            this.dh = ThemeResolver.b(XInputGroup.i, XInputGroup.fw, XInputGroup.d3);
            this.m6 = ThemeResolver.d(XInputGroup.i, XInputGroup.nf, XInputGroup.m9);
            this.tm = ThemeResolver.f(XInputGroup.i, XInputGroup.tv, XInputGroup.tp);
            this.pq = ThemeResolver.e(XInputGroup.i, XInputGroup.ro, XInputGroup.p8);
            this.pr = ThemeResolver.e(XInputGroup.i, XInputGroup.rp, XInputGroup.p9);
            this.ps = ThemeResolver.e(XInputGroup.i, XInputGroup.rq, XInputGroup.qa);
            this.dq = ThemeResolver.b(XInputGroup.i, XInputGroup.f4, XInputGroup.eb);
            this.dp = ThemeResolver.b(XInputGroup.i, XInputGroup.f3, XInputGroup.ea);
            this.dl = ThemeResolver.b(XInputGroup.i, XInputGroup.f0, XInputGroup.d7);
            this.pv = ThemeResolver.e(XInputGroup.i, XInputGroup.rt, XInputGroup.qd);
            this.pw = ThemeResolver.e(XInputGroup.i, XInputGroup.ru, XInputGroup.qe);
            this.pu = ThemeResolver.e(XInputGroup.i, XInputGroup.rs, XInputGroup.qc);
            this.pt = ThemeResolver.e(XInputGroup.i, XInputGroup.rr, XInputGroup.qb);
            this.dm = ThemeResolver.b(XInputGroup.i, XInputGroup.f1, XInputGroup.d8);
            this.dk = ThemeResolver.b(XInputGroup.i, XInputGroup.fz, XInputGroup.d6);
            this.di = ThemeResolver.b(XInputGroup.i, XInputGroup.fx, XInputGroup.d4);
            this.dj = ThemeResolver.b(XInputGroup.i, XInputGroup.fy, XInputGroup.d5);
            this.dn = ThemeResolver.b(XInputGroup.i, XInputGroup.f2, XInputGroup.d9);
            this.pp = ThemeResolver.e(XInputGroup.i, XInputGroup.rn, XInputGroup.p7);
            this.c5 = ThemeResolver.b(XInputGroup.i, XInputGroup.fk, XInputGroup.dr);
            this.c6 = ThemeResolver.b(XInputGroup.i, XInputGroup.fl, XInputGroup.ds);
            this.m5 = ThemeResolver.d(XInputGroup.i, XInputGroup.ne, XInputGroup.m8);
            this.tl = ThemeResolver.f(XInputGroup.i, XInputGroup.tu, XInputGroup.to);
            this.pi = ThemeResolver.e(XInputGroup.i, XInputGroup.rg, XInputGroup.p0);
            this.pj = ThemeResolver.e(XInputGroup.i, XInputGroup.rh, XInputGroup.p1);
            this.pk = ThemeResolver.e(XInputGroup.i, XInputGroup.ri, XInputGroup.p2);
            this.de = ThemeResolver.b(XInputGroup.i, XInputGroup.ft, XInputGroup.d0);
            this.dd = ThemeResolver.b(XInputGroup.i, XInputGroup.fs, XInputGroup.dz);
            this.da = ThemeResolver.b(XInputGroup.i, XInputGroup.fp, XInputGroup.dw);
            this.pn = ThemeResolver.e(XInputGroup.i, XInputGroup.rl, XInputGroup.p5);
            this.po = ThemeResolver.e(XInputGroup.i, XInputGroup.rm, XInputGroup.p6);
            this.pm = ThemeResolver.e(XInputGroup.i, XInputGroup.rk, XInputGroup.p4);
            this.pl = ThemeResolver.e(XInputGroup.i, XInputGroup.rj, XInputGroup.p3);
            this.db = ThemeResolver.b(XInputGroup.i, XInputGroup.fq, XInputGroup.dx);
            this.c9 = ThemeResolver.b(XInputGroup.i, XInputGroup.fo, XInputGroup.dv);
            this.c7 = ThemeResolver.b(XInputGroup.i, XInputGroup.fm, XInputGroup.dt);
            this.c8 = ThemeResolver.b(XInputGroup.i, XInputGroup.fn, XInputGroup.du);
            this.dc = ThemeResolver.b(XInputGroup.i, XInputGroup.fr, XInputGroup.dy);
            this.ph = ThemeResolver.e(XInputGroup.i, XInputGroup.rf, XInputGroup.pz);
            this.gy = ThemeResolver.b(XInputGroup.i, XInputGroup.gk, XInputGroup.er);
            this.gz = ThemeResolver.b(XInputGroup.i, XInputGroup.gl, XInputGroup.es);
            this.nj = ThemeResolver.d(XInputGroup.i, XInputGroup.ni, XInputGroup.nc);
            this.tz = ThemeResolver.f(XInputGroup.i, XInputGroup.ty, XInputGroup.ts);
            this.si = ThemeResolver.e(XInputGroup.i, XInputGroup.r8, XInputGroup.qs);
            this.sj = ThemeResolver.e(XInputGroup.i, XInputGroup.r9, XInputGroup.qt);
            this.sk = ThemeResolver.e(XInputGroup.i, XInputGroup.sa, XInputGroup.qu);
            this.g7 = ThemeResolver.b(XInputGroup.i, XInputGroup.gt, XInputGroup.e0);
            this.g6 = ThemeResolver.b(XInputGroup.i, XInputGroup.gs, XInputGroup.ez);
            this.g3 = ThemeResolver.b(XInputGroup.i, XInputGroup.gp, XInputGroup.ew);
            this.sn = ThemeResolver.e(XInputGroup.i, XInputGroup.sd, XInputGroup.qx);
            this.so = ThemeResolver.e(XInputGroup.i, XInputGroup.se, XInputGroup.qy);
            this.sm = ThemeResolver.e(XInputGroup.i, XInputGroup.sc, XInputGroup.qw);
            this.sl = ThemeResolver.e(XInputGroup.i, XInputGroup.sb, XInputGroup.qv);
            this.g4 = ThemeResolver.b(XInputGroup.i, XInputGroup.gq, XInputGroup.ex);
            this.g2 = ThemeResolver.b(XInputGroup.i, XInputGroup.go, XInputGroup.ev);
            this.g0 = ThemeResolver.b(XInputGroup.i, XInputGroup.gm, XInputGroup.et);
            this.g1 = ThemeResolver.b(XInputGroup.i, XInputGroup.gn, XInputGroup.eu);
            this.g5 = ThemeResolver.b(XInputGroup.i, XInputGroup.gr, XInputGroup.ey);
            this.sh = ThemeResolver.e(XInputGroup.i, XInputGroup.r7, XInputGroup.qr);
            this.nn = ThemeResolver.e(XInputGroup.i, XInputGroup.re, XInputGroup.py);
            this.no = ThemeResolver.e(XInputGroup.i, XInputGroup.rv, XInputGroup.qf);
            this.am = ThemeResolver.b(XInputGroup.i, XInputGroup.fu, XInputGroup.d1);
            this.an = ThemeResolver.b(XInputGroup.i, XInputGroup.f5, XInputGroup.ec);
            this.mu = ThemeResolver.d(XInputGroup.i, XInputGroup.ng, XInputGroup.na);
            this.ta = ThemeResolver.f(XInputGroup.i, XInputGroup.tw, XInputGroup.tq);
            this.av = ThemeResolver.b(XInputGroup.i, XInputGroup.gx, XInputGroup.e4);
            this.au = ThemeResolver.b(XInputGroup.i, XInputGroup.gw, XInputGroup.e3);
            this.ar = ThemeResolver.b(XInputGroup.i, XInputGroup.f9, XInputGroup.eg);
            this.nr = ThemeResolver.e(XInputGroup.i, XInputGroup.sf, XInputGroup.qz);
            this.ns = ThemeResolver.e(XInputGroup.i, XInputGroup.sg, XInputGroup.q0);
            this.nq = ThemeResolver.e(XInputGroup.i, XInputGroup.ry, XInputGroup.qi);
            this.np = ThemeResolver.e(XInputGroup.i, XInputGroup.rx, XInputGroup.qh);
            this.as = ThemeResolver.b(XInputGroup.i, XInputGroup.gu, XInputGroup.e1);
            this.aq = ThemeResolver.b(XInputGroup.i, XInputGroup.f8, XInputGroup.ef);
            this.ao = ThemeResolver.b(XInputGroup.i, XInputGroup.f6, XInputGroup.ed);
            this.ap = ThemeResolver.b(XInputGroup.i, XInputGroup.f7, XInputGroup.ee);
            this.at = ThemeResolver.b(XInputGroup.i, XInputGroup.gv, XInputGroup.e2);
            this.nm = ThemeResolver.e(XInputGroup.i, XInputGroup.rd, XInputGroup.px);
            this.a6 = NaN;
            this.bh = NaN;
            this.nu = null;
            this.mx = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.td = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b9 = NaN;
            this.b8 = NaN;
            this.bl = NaN;
            this.oq = null;
            this.or = null;
            this.ob = null;
            this.oa = null;
            this.b6 = NaN;
            this.bk = NaN;
            this.bi = NaN;
            this.bj = NaN;
            this.b7 = NaN;
            this.nt = null;
            this.bm = NaN;
            this.bn = NaN;
            this.oe = null;
            this.od = null;
            this.my = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.te = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bv = NaN;
            this.bu = NaN;
            this.br = NaN;
            this.oh = null;
            this.oi = null;
            this.og = null;
            this.of = null;
            this.bs = NaN;
            this.bq = NaN;
            this.bo = NaN;
            this.bp = NaN;
            this.bt = NaN;
            this.oc = null;
            this.a7 = NaN;
            this.a8 = NaN;
            this.n4 = null;
            this.n3 = null;
            this.mw = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.tc = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bg = NaN;
            this.bf = NaN;
            this.bc = NaN;
            this.n7 = null;
            this.n8 = null;
            this.n6 = null;
            this.n5 = null;
            this.bd = NaN;
            this.bb = NaN;
            this.a9 = NaN;
            this.ba = NaN;
            this.be = NaN;
            this.n2 = null;
            this.aw = NaN;
            this.ax = NaN;
            this.nx = null;
            this.nw = null;
            this.mv = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.tb = new Thickness(1, NaN, NaN, NaN, NaN);
            this.a5 = NaN;
            this.a4 = NaN;
            this.a1 = NaN;
            this.n0 = null;
            this.n1 = null;
            this.nz = null;
            this.ny = null;
            this.a2 = NaN;
            this.a0 = NaN;
            this.ay = NaN;
            this.az = NaN;
            this.a3 = NaN;
            this.nv = null;
            this.bw = NaN;
            this.bx = NaN;
            this.ol = null;
            this.ok = null;
            this.mz = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.tf = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b5 = NaN;
            this.b4 = NaN;
            this.b1 = NaN;
            this.oo = null;
            this.op = null;
            this.on = null;
            this.om = null;
            this.b2 = NaN;
            this.b0 = NaN;
            this.by = NaN;
            this.bz = NaN;
            this.b3 = NaN;
            this.oj = null;
            this.x = false;
            this.t = false;
            this.z = false;
            this.v = false;
            this.y = false;
            this.u = false;
            this.r = false;
            this.n9 = null;
            this.ib = "ig-inputgroup-" + XInputGroup.h8++;
            this.w = false;
            this.propertyChanged = null;
            this.e = new XInputGroupInputCollection();
            this.p = null;
            this.ab = false;
            this.s = false;
            this.aa = false;
            this.h9 = toNullable(Number_$type, null);
            let a = new InputGroupView();
            a.d = this;
            this.view = a;
            this.view.ak();
            let b = this.e;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.lx));
            let c = this.e;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.ly));
        }
        ly(a, b) {
            this.mn();
            this.view.ad();
        }
        appendContentChild(a) {
            this.view.ab(a);
        }
        mj(a) {
            this.view.an(a);
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.me("DisplayType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        }
        get n() {
            return this.l;
        }
        set n(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.me("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get m() {
            return this.k;
        }
        set m(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.me("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        l4(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XLabel.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        l5(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XPrefix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        l3(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XInput.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        l6(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XSuffix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lx(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    let d = c;
                    if (d != null) {
                        d.b = null;
                    }
                    this.view.ae(d);
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    let f = e;
                    if (f != null) {
                        f.b = this;
                    }
                    this.view.ac(f);
                }
            }
            this.ml();
            this.ad = true;
            try {
                this.mt();
            }
            finally {
                this.ad = false;
            }
            this.mq();
            this.mp();
            this.mr();
            this.ms();
            this.mn();
        }
        get j() {
            return this.h;
        }
        set j(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.me("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        me(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.mh(a, b, c);
        }
        mh(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.mm(this.j);
                    this.mo();
                    this.l4((d) => d.p = this.j == 0 ? 2 : this.j);
                    break;
                case "ActualBorderColor":
                case "ActualBackgroundColor":
                case "ActualBorderWidth":
                case "ActualFocusBorderColor":
                case "ActualFocusBorderWidth":
                case "ActualCornerRadius":
                case "ActualContentPadding":
                case "ActualUnderlineOpacity":
                case "ActualUnderlineRippleOpacity":
                case "ActualUnderlineRippleWidth":
                case "ActualUnderlineRippleColor":
                case "ActualUnderlineColor":
                case "ActualHoverUnderlineColor":
                case "ActualUnderlineWidth":
                case "ActualHoverUnderlineWidth":
                case "ActualHoverUnderlineOpacity":
                case "ActualFocusUnderlineColor":
                case "ActualFocusUnderlineOpacity":
                case "ActualFocusUnderlineRippleOpacity":
                case "IsHovered":
                    this.aa = true;
                    this.ab = true;
                    this.s = true;
                    this.mn();
                    break;
                case "BorderColor":
                case "BackgroundColor":
                case "BorderWidth":
                case "FocusBorderColor":
                case "FocusBorderWidth":
                case "CornerRadius":
                case "ContentPadding":
                case "UnderlineOpacity":
                case "UnderlineRippleOpacity":
                case "UnderlineRippleWidth":
                case "UnderlineRippleColor":
                case "UnderlineColor":
                case "HoverUnderlineColor":
                case "UnderlineWidth":
                case "HoverUnderlineWidth":
                case "HoverUnderlineOpacity":
                case "FocusUnderlineColor":
                case "FocusUnderlineOpacity":
                case "FocusUnderlineRippleOpacity":
                case "LineTypeBorderColor":
                case "LineTypeBackgroundColor":
                case "LineTypeBorderWidth":
                case "LineTypeFocusBorderColor":
                case "LineTypeFocusBorderWidth":
                case "LineTypeCornerRadius":
                case "LineTypeContentPadding":
                case "LineTypeUnderlineOpacity":
                case "LineTypeUnderlineRippleOpacity":
                case "LineTypeUnderlineRippleWidth":
                case "LineTypeUnderlineRippleColor":
                case "LineTypeUnderlineColor":
                case "LineTypeHoverUnderlineColor":
                case "LineTypeUnderlineWidth":
                case "LineTypeHoverUnderlineWidth":
                case "LineTypeHoverUnderlineOpacity":
                case "LineTypeFocusUnderlineColor":
                case "LineTypeFocusUnderlineOpacity":
                case "LineTypeFocusUnderlineRippleOpacity":
                case "BoxTypeBorderColor":
                case "BoxTypeBackgroundColor":
                case "BoxTypeBorderWidth":
                case "BoxTypeFocusBorderColor":
                case "BoxTypeFocusBorderWidth":
                case "BoxTypeCornerRadius":
                case "BoxTypeContentPadding":
                case "BoxTypeUnderlineOpacity":
                case "BoxTypeUnderlineRippleOpacity":
                case "BoxTypeUnderlineRippleWidth":
                case "BoxTypeUnderlineRippleColor":
                case "BoxTypeUnderlineColor":
                case "BoxTypeHoverUnderlineColor":
                case "BoxTypeUnderlineWidth":
                case "BoxTypeHoverUnderlineWidth":
                case "BoxTypeHoverUnderlineOpacity":
                case "BoxTypeFocusUnderlineColor":
                case "BoxTypeFocusUnderlineOpacity":
                case "BoxTypeFocusUnderlineRippleOpacity":
                case "BorderTypeBorderColor":
                case "BorderTypeBackgroundColor":
                case "BorderTypeBorderWidth":
                case "BorderTypeFocusBorderColor":
                case "BorderTypeFocusBorderWidth":
                case "BorderTypeCornerRadius":
                case "BorderTypeContentPadding":
                case "BorderTypeUnderlineOpacity":
                case "BorderTypeUnderlineRippleOpacity":
                case "BorderTypeUnderlineRippleWidth":
                case "BorderTypeUnderlineRippleColor":
                case "BorderTypeUnderlineColor":
                case "BorderTypeHoverUnderlineColor":
                case "BorderTypeUnderlineWidth":
                case "BorderTypeHoverUnderlineWidth":
                case "BorderTypeHoverUnderlineOpacity":
                case "BorderTypeFocusUnderlineColor":
                case "BorderTypeFocusUnderlineOpacity":
                case "BorderTypeFocusUnderlineRippleOpacity":
                case "DisplayType":
                    this.mo();
                    break;
                case "ActualDensity":
                    this.view.ap();
                    this.mo();
                    break;
                case "Density":
                    this.m = this.n == 0 ? 1 : this.n;
                    break;
                case "IsFocused":
                    this.mc();
                    this.mn();
                    break;
                case "IsExpanded":
                    this.t = true;
                    this.ac = this.ah;
                    break;
                case "ActualIsExpanded":
                    this.l7();
                    break;
            }
        }
        static m3(a, b) {
            return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
        }
        static tj(a, b) {
            return new Thickness(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.e) ? a.e : b.e, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b);
        }
        mq() {
            this.l4((a) => {
                a.t = this.m;
                a.p = this.j == 0 ? 2 : this.j;
                switch (this.d) {
                    case 0:
                        a.l = 0;
                        break;
                    case 1:
                        a.l = 1;
                        break;
                    case 2:
                    case 3:
                        a.l = 2;
                        break;
                }
                a.ck(this.ac, false);
            });
        }
        mr() {
            this.l5((a) => {
                switch (this.d) {
                    case 0:
                        a.k = 0;
                        break;
                    case 1:
                        a.k = 1;
                        break;
                    case 2:
                    case 3:
                        a.k = 2;
                        break;
                }
            });
        }
        mp() {
            this.l3((a) => {
                a.x = this.m;
                switch (this.d) {
                    case 0:
                        a.n = 0;
                        break;
                    case 1:
                        a.n = 1;
                        break;
                    case 2:
                    case 3:
                        a.n = 2;
                        break;
                }
                a.dh(this.al, false);
            });
        }
        ms() {
            this.l6((a) => {
                switch (this.d) {
                    case 0:
                        a.k = 0;
                        break;
                    case 1:
                        a.k = 1;
                        break;
                    case 2:
                    case 3:
                        a.k = 2;
                        break;
                }
            });
        }
        mo() {
            this.mq();
            this.mp();
            this.mr();
            this.ms();
            switch (this.d) {
                case 0:
                    this.ot = this.o0 != null ? this.o0 : this.sv != null ? this.sv : this.q6;
                    this.os = this.oz != null ? this.oz : this.su != null ? this.su : this.q5;
                    this.ca = !isNaN_(this.cu) ? this.cu : !isNaN_(this.hh) ? this.hh : this.fa;
                    this.ou = this.sr != null ? this.sr : this.sw != null ? this.sw : this.q7;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hi) ? this.hi : this.fb;
                    this.m0 = XInputGroup.m3(this.m4, XInputGroup.m3(this.nk, this.nd));
                    this.tg = XInputGroup.tj(this.tk, XInputGroup.tj(this.t0, this.tt));
                    this.cg = !isNaN_(this.h1) ? this.h1 : !isNaN_(this.hn) ? this.hn : this.fg;
                    this.ch = !isNaN_(this.h2) ? this.h2 : !isNaN_(this.ho) ? this.ho : this.fh;
                    this.ci = !isNaN_(this.h3) ? this.h3 : !isNaN_(this.hp) ? this.hp : this.fi;
                    this.oy = this.s9 != null ? this.s9 : this.s0 != null ? this.s0 : this.rc;
                    this.ox = this.s8 != null ? this.s8 : this.sz != null ? this.sz : this.rb;
                    this.ow = this.st != null ? this.st : this.sy != null ? this.sy : this.ra;
                    this.cj = !isNaN_(this.h4) ? this.h4 : !isNaN_(this.hq) ? this.hq : this.fj;
                    this.cf = !isNaN_(this.hg) ? this.hg : !isNaN_(this.hm) ? this.hm : this.ff;
                    this.ce = !isNaN_(this.hf) ? this.hf : !isNaN_(this.hl) ? this.hl : this.fe;
                    this.ov = this.ss != null ? this.ss : this.sx != null ? this.sx : this.q9;
                    this.cc = !isNaN_(this.hd) ? this.hd : !isNaN_(this.hj) ? this.hj : this.fc;
                    this.cd = !isNaN_(this.he) ? this.he : !isNaN_(this.hk) ? this.hk : this.fd;
                    break;
                case 1:
                    this.ot = this.o0 != null ? this.o0 : this.o9 != null ? this.o9 : this.pq;
                    this.os = this.oz != null ? this.oz : this.o8 != null ? this.o8 : this.pp;
                    this.ca = !isNaN_(this.cu) ? this.cu : !isNaN_(this.cv) ? this.cv : this.dg;
                    this.ou = this.sr != null ? this.sr : this.pa != null ? this.pa : this.pr;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cw) ? this.cw : this.dh;
                    this.m0 = XInputGroup.m3(this.m4, XInputGroup.m3(this.m2, this.m6));
                    this.tg = XInputGroup.tj(this.tk, XInputGroup.tj(this.ti, this.tm));
                    this.cg = !isNaN_(this.h1) ? this.h1 : !isNaN_(this.c1) ? this.c1 : this.dm;
                    this.ch = !isNaN_(this.h2) ? this.h2 : !isNaN_(this.c2) ? this.c2 : this.dn;
                    this.ci = !isNaN_(this.h3) ? this.h3 : !isNaN_(this.c3) ? this.c3 : this.dp;
                    this.oy = this.s9 != null ? this.s9 : this.pe != null ? this.pe : this.pw;
                    this.ox = this.s8 != null ? this.s8 : this.pd != null ? this.pd : this.pv;
                    this.ow = this.st != null ? this.st : this.pc != null ? this.pc : this.pu;
                    this.cj = !isNaN_(this.h4) ? this.h4 : !isNaN_(this.c4) ? this.c4 : this.dq;
                    this.cf = !isNaN_(this.hg) ? this.hg : !isNaN_(this.c0) ? this.c0 : this.dl;
                    this.ce = !isNaN_(this.hf) ? this.hf : !isNaN_(this.cz) ? this.cz : this.dk;
                    this.ov = this.ss != null ? this.ss : this.pb != null ? this.pb : this.pt;
                    this.cc = !isNaN_(this.hd) ? this.hd : !isNaN_(this.cx) ? this.cx : this.di;
                    this.cd = !isNaN_(this.he) ? this.he : !isNaN_(this.cy) ? this.cy : this.dj;
                    break;
                case 2:
                    this.ot = this.o0 != null ? this.o0 : this.o2 != null ? this.o2 : this.pi;
                    this.os = this.oz != null ? this.oz : this.o1 != null ? this.o1 : this.ph;
                    this.ca = !isNaN_(this.cu) ? this.cu : !isNaN_(this.ck) ? this.ck : this.c5;
                    this.ou = this.sr != null ? this.sr : this.o3 != null ? this.o3 : this.pj;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cl) ? this.cl : this.c6;
                    this.m0 = XInputGroup.m3(this.m4, XInputGroup.m3(this.m1, this.m5));
                    this.tg = XInputGroup.tj(this.tk, XInputGroup.tj(this.th, this.tl));
                    this.cg = !isNaN_(this.h1) ? this.h1 : !isNaN_(this.cq) ? this.cq : this.db;
                    this.ch = !isNaN_(this.h2) ? this.h2 : !isNaN_(this.cr) ? this.cr : this.dc;
                    this.ci = !isNaN_(this.h3) ? this.h3 : !isNaN_(this.cs) ? this.cs : this.dd;
                    this.oy = this.s9 != null ? this.s9 : this.o7 != null ? this.o7 : this.po;
                    this.ox = this.s8 != null ? this.s8 : this.o6 != null ? this.o6 : this.pn;
                    this.ow = this.st != null ? this.st : this.o5 != null ? this.o5 : this.pm;
                    this.cj = !isNaN_(this.h4) ? this.h4 : !isNaN_(this.ct) ? this.ct : this.de;
                    this.cf = !isNaN_(this.hg) ? this.hg : !isNaN_(this.cp) ? this.cp : this.da;
                    this.ce = !isNaN_(this.hf) ? this.hf : !isNaN_(this.co) ? this.co : this.c9;
                    this.ov = this.ss != null ? this.ss : this.o4 != null ? this.o4 : this.pl;
                    this.cc = !isNaN_(this.hd) ? this.hd : !isNaN_(this.cm) ? this.cm : this.c7;
                    this.cd = !isNaN_(this.he) ? this.he : !isNaN_(this.cn) ? this.cn : this.c8;
                    break;
                case 3:
                    this.ot = this.o0 != null ? this.o0 : this.s2 != null ? this.s2 : this.si;
                    this.os = this.oz != null ? this.oz : this.s1 != null ? this.s1 : this.sh;
                    this.ca = !isNaN_(this.cu) ? this.cu : !isNaN_(this.hr) ? this.hr : this.gy;
                    this.ou = this.sr != null ? this.sr : this.s3 != null ? this.s3 : this.sj;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hs) ? this.hs : this.gz;
                    this.m0 = XInputGroup.m3(this.m4, XInputGroup.m3(this.nl, this.nj));
                    this.tg = XInputGroup.tj(this.tk, XInputGroup.tj(this.t1, this.tz));
                    this.cg = !isNaN_(this.h1) ? this.h1 : !isNaN_(this.hx) ? this.hx : this.g4;
                    this.ch = !isNaN_(this.h2) ? this.h2 : !isNaN_(this.hy) ? this.hy : this.g5;
                    this.ci = !isNaN_(this.h3) ? this.h3 : !isNaN_(this.hz) ? this.hz : this.g6;
                    this.oy = this.s9 != null ? this.s9 : this.s7 != null ? this.s7 : this.so;
                    this.ox = this.s8 != null ? this.s8 : this.s6 != null ? this.s6 : this.sn;
                    this.ow = this.st != null ? this.st : this.s5 != null ? this.s5 : this.sm;
                    this.cj = !isNaN_(this.h4) ? this.h4 : !isNaN_(this.h0) ? this.h0 : this.g7;
                    this.cf = !isNaN_(this.hg) ? this.hg : !isNaN_(this.hw) ? this.hw : this.g3;
                    this.ce = !isNaN_(this.hf) ? this.hf : !isNaN_(this.hv) ? this.hv : this.g2;
                    this.ov = this.ss != null ? this.ss : this.s4 != null ? this.s4 : this.sl;
                    this.cc = !isNaN_(this.hd) ? this.hd : !isNaN_(this.ht) ? this.ht : this.g0;
                    this.cd = !isNaN_(this.he) ? this.he : !isNaN_(this.hu) ? this.hu : this.g1;
                    break;
            }
        }
        mn() {
            this.l4((a) => {
            });
            this.l3((a) => {
            });
            let a = this.view.v;
            let b = this.view.u;
            let c = this.view.x;
            let d = this.view.y;
            let e = this.p != null && this.p.playState == 1;
            let f = this.q != null && this.q.playState == 1;
            let g = this.o != null && this.o.playState == 1;
            NativeUI.m(a, this.m0);
            NativeUI.m(b, this.m0);
            NativeUI.k(a, this.os);
            NativeUI.v(a, this.tg);
            if (this.ai) {
                if (!g) {
                    NativeUI.l(b, this.ou);
                    NativeUI.n(b, new Thickness(0, this.cb));
                }
                if (!f) {
                    NativeUI.k(c, this.ov);
                }
            }
            else {
                if (!f) {
                    if (this.aj) {
                        NativeUI.k(c, this.ow);
                        NativeUI.u(c, this.ce);
                        NativeUI.r(c, this.cf);
                    }
                    else {
                        NativeUI.k(c, this.ox);
                        NativeUI.u(c, this.cg);
                        NativeUI.r(c, this.cj);
                    }
                }
                if (!g) {
                    NativeUI.l(b, this.ot);
                    NativeUI.n(b, new Thickness(0, this.ca));
                }
                if (!f) {
                    NativeUI.k(a, this.os);
                }
            }
            if (!e) {
                NativeUI.k(d, this.oy);
                NativeUI.r(d, this.ci);
                NativeUI.u(d, this.ch);
            }
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        onChildrenMutated() {
            this.l3((a) => a.view.az());
            this.l4((a) => a.view.af());
            this.l5((a) => a.view.q());
            this.l6((a) => a.view.q());
        }
        l1() {
            this.view.af();
            let a = false;
            if (this.q == null) {
                this.q = KeyFrameAnimationFactory.f.c(this.view.c(this.a).m(new AnimationKeyFrameProperty(2, this.ot)).m(new AnimationKeyFrameProperty(2, this.ou)));
            }
            if (this.o == null) {
                this.o = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(3, this.ot), new AnimationKeyFrameProperty(4, this.d == 2 || this.d == 3 ? new Thickness(0, this.ca) : new Thickness(0, 0))).m(new AnimationKeyFrameProperty(3, this.ou), new AnimationKeyFrameProperty(4, this.d == 2 || this.d == 3 ? new Thickness(0, this.cb) : new Thickness(0, 0))));
            }
            if (this.p == null) {
                this.p = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(2, this.ou), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.5;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(2, this.ou), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get af() {
            let a = false;
            this.l3((b) => {
                if (b.ap) {
                    a = true;
                }
            });
            return a;
        }
        md() {
            this.ac = this.t ? this.ah : this.af ? true : false;
            this.ai = false;
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        mm(a) {
            this.df = ThemeResolver.b(a, XInputGroup.fu, XInputGroup.d1);
            this.e5 = ThemeResolver.b(a, XInputGroup.f5, XInputGroup.ec);
            this.m7 = ThemeResolver.d(a, XInputGroup.ng, XInputGroup.na);
            this.tn = ThemeResolver.f(a, XInputGroup.tw, XInputGroup.tq);
            this.pg = ThemeResolver.e(a, XInputGroup.re, XInputGroup.py);
            this.q1 = ThemeResolver.e(a, XInputGroup.rv, XInputGroup.qf);
            this.q2 = ThemeResolver.e(a, XInputGroup.rw, XInputGroup.qg);
            this.hb = ThemeResolver.b(a, XInputGroup.gx, XInputGroup.e4);
            this.ha = ThemeResolver.b(a, XInputGroup.gw, XInputGroup.e3);
            this.e9 = ThemeResolver.b(a, XInputGroup.f9, XInputGroup.eg);
            this.sp = ThemeResolver.e(a, XInputGroup.sf, XInputGroup.qz);
            this.sq = ThemeResolver.e(a, XInputGroup.sg, XInputGroup.q0);
            this.q4 = ThemeResolver.e(a, XInputGroup.ry, XInputGroup.qi);
            this.q3 = ThemeResolver.e(a, XInputGroup.rx, XInputGroup.qh);
            this.g8 = ThemeResolver.b(a, XInputGroup.gu, XInputGroup.e1);
            this.e8 = ThemeResolver.b(a, XInputGroup.f8, XInputGroup.ef);
            this.e6 = ThemeResolver.b(a, XInputGroup.f6, XInputGroup.ed);
            this.e7 = ThemeResolver.b(a, XInputGroup.f7, XInputGroup.ee);
            this.g9 = ThemeResolver.b(a, XInputGroup.gv, XInputGroup.e2);
            this.pf = ThemeResolver.e(a, XInputGroup.rd, XInputGroup.px);
            this.fa = ThemeResolver.b(a, XInputGroup.ga, XInputGroup.eh);
            this.fb = ThemeResolver.b(a, XInputGroup.gb, XInputGroup.ei);
            this.nd = ThemeResolver.d(a, XInputGroup.nh, XInputGroup.nb);
            this.tt = ThemeResolver.f(a, XInputGroup.tx, XInputGroup.tr);
            this.q6 = ThemeResolver.e(a, XInputGroup.r0, XInputGroup.qk);
            this.q7 = ThemeResolver.e(a, XInputGroup.r1, XInputGroup.ql);
            this.q8 = ThemeResolver.e(a, XInputGroup.r2, XInputGroup.qm);
            this.fj = ThemeResolver.b(a, XInputGroup.gj, XInputGroup.eq);
            this.fi = ThemeResolver.b(a, XInputGroup.gi, XInputGroup.ep);
            this.ff = ThemeResolver.b(a, XInputGroup.gf, XInputGroup.em);
            this.rb = ThemeResolver.e(a, XInputGroup.r5, XInputGroup.qp);
            this.rc = ThemeResolver.e(a, XInputGroup.r6, XInputGroup.qq);
            this.ra = ThemeResolver.e(a, XInputGroup.r4, XInputGroup.qo);
            this.q9 = ThemeResolver.e(a, XInputGroup.r3, XInputGroup.qn);
            this.fg = ThemeResolver.b(a, XInputGroup.gg, XInputGroup.en);
            this.fe = ThemeResolver.b(a, XInputGroup.ge, XInputGroup.el);
            this.fc = ThemeResolver.b(a, XInputGroup.gc, XInputGroup.ej);
            this.fd = ThemeResolver.b(a, XInputGroup.gd, XInputGroup.ek);
            this.fh = ThemeResolver.b(a, XInputGroup.gh, XInputGroup.eo);
            this.q5 = ThemeResolver.e(a, XInputGroup.rz, XInputGroup.qj);
            this.dg = ThemeResolver.b(a, XInputGroup.fv, XInputGroup.d2);
            this.dh = ThemeResolver.b(a, XInputGroup.fw, XInputGroup.d3);
            this.m6 = ThemeResolver.d(a, XInputGroup.nf, XInputGroup.m9);
            this.tm = ThemeResolver.f(a, XInputGroup.tv, XInputGroup.tp);
            this.pq = ThemeResolver.e(a, XInputGroup.ro, XInputGroup.p8);
            this.pr = ThemeResolver.e(a, XInputGroup.rp, XInputGroup.p9);
            this.ps = ThemeResolver.e(a, XInputGroup.rq, XInputGroup.qa);
            this.dq = ThemeResolver.b(a, XInputGroup.f4, XInputGroup.eb);
            this.dp = ThemeResolver.b(a, XInputGroup.f3, XInputGroup.ea);
            this.dl = ThemeResolver.b(a, XInputGroup.f0, XInputGroup.d7);
            this.pv = ThemeResolver.e(a, XInputGroup.rt, XInputGroup.qd);
            this.pw = ThemeResolver.e(a, XInputGroup.ru, XInputGroup.qe);
            this.pu = ThemeResolver.e(a, XInputGroup.rs, XInputGroup.qc);
            this.pt = ThemeResolver.e(a, XInputGroup.rr, XInputGroup.qb);
            this.dm = ThemeResolver.b(a, XInputGroup.f1, XInputGroup.d8);
            this.dk = ThemeResolver.b(a, XInputGroup.fz, XInputGroup.d6);
            this.di = ThemeResolver.b(a, XInputGroup.fx, XInputGroup.d4);
            this.dj = ThemeResolver.b(a, XInputGroup.fy, XInputGroup.d5);
            this.dn = ThemeResolver.b(a, XInputGroup.f2, XInputGroup.d9);
            this.pp = ThemeResolver.e(a, XInputGroup.rn, XInputGroup.p7);
            this.c5 = ThemeResolver.b(a, XInputGroup.fk, XInputGroup.dr);
            this.c6 = ThemeResolver.b(a, XInputGroup.fl, XInputGroup.ds);
            this.m5 = ThemeResolver.d(a, XInputGroup.ne, XInputGroup.m8);
            this.tl = ThemeResolver.f(a, XInputGroup.tu, XInputGroup.to);
            this.pi = ThemeResolver.e(a, XInputGroup.rg, XInputGroup.p0);
            this.pj = ThemeResolver.e(a, XInputGroup.rh, XInputGroup.p1);
            this.pk = ThemeResolver.e(a, XInputGroup.ri, XInputGroup.p2);
            this.de = ThemeResolver.b(a, XInputGroup.ft, XInputGroup.d0);
            this.dd = ThemeResolver.b(a, XInputGroup.fs, XInputGroup.dz);
            this.da = ThemeResolver.b(a, XInputGroup.fp, XInputGroup.dw);
            this.pn = ThemeResolver.e(a, XInputGroup.rl, XInputGroup.p5);
            this.po = ThemeResolver.e(a, XInputGroup.rm, XInputGroup.p6);
            this.pm = ThemeResolver.e(a, XInputGroup.rk, XInputGroup.p4);
            this.pl = ThemeResolver.e(a, XInputGroup.rj, XInputGroup.p3);
            this.db = ThemeResolver.b(a, XInputGroup.fq, XInputGroup.dx);
            this.c9 = ThemeResolver.b(a, XInputGroup.fo, XInputGroup.dv);
            this.c7 = ThemeResolver.b(a, XInputGroup.fm, XInputGroup.dt);
            this.c8 = ThemeResolver.b(a, XInputGroup.fn, XInputGroup.du);
            this.dc = ThemeResolver.b(a, XInputGroup.fr, XInputGroup.dy);
            this.ph = ThemeResolver.e(a, XInputGroup.rf, XInputGroup.pz);
            this.gy = ThemeResolver.b(a, XInputGroup.gk, XInputGroup.er);
            this.gz = ThemeResolver.b(a, XInputGroup.gl, XInputGroup.es);
            this.nj = ThemeResolver.d(a, XInputGroup.ni, XInputGroup.nc);
            this.tz = ThemeResolver.f(a, XInputGroup.ty, XInputGroup.ts);
            this.si = ThemeResolver.e(a, XInputGroup.r8, XInputGroup.qs);
            this.sj = ThemeResolver.e(a, XInputGroup.r9, XInputGroup.qt);
            this.sk = ThemeResolver.e(a, XInputGroup.sa, XInputGroup.qu);
            this.g7 = ThemeResolver.b(a, XInputGroup.gt, XInputGroup.e0);
            this.g6 = ThemeResolver.b(a, XInputGroup.gs, XInputGroup.ez);
            this.g3 = ThemeResolver.b(a, XInputGroup.gp, XInputGroup.ew);
            this.sn = ThemeResolver.e(a, XInputGroup.sd, XInputGroup.qx);
            this.so = ThemeResolver.e(a, XInputGroup.se, XInputGroup.qy);
            this.sm = ThemeResolver.e(a, XInputGroup.sc, XInputGroup.qw);
            this.sl = ThemeResolver.e(a, XInputGroup.sb, XInputGroup.qv);
            this.g4 = ThemeResolver.b(a, XInputGroup.gq, XInputGroup.ex);
            this.g2 = ThemeResolver.b(a, XInputGroup.go, XInputGroup.ev);
            this.g0 = ThemeResolver.b(a, XInputGroup.gm, XInputGroup.et);
            this.g1 = ThemeResolver.b(a, XInputGroup.gn, XInputGroup.eu);
            this.g5 = ThemeResolver.b(a, XInputGroup.gr, XInputGroup.ey);
            this.sh = ThemeResolver.e(a, XInputGroup.r7, XInputGroup.qr);
        }
        l7() {
            this.l1();
            if (this.ac) {
                this.l4((a) => a.ck(true, !this.ad));
                this.l3((a) => a.dh(this.al, !this.ad));
            }
            else {
                this.l4((a) => a.ck(false, !this.ad));
                this.l3((a) => a.dh(this.al, !this.ad));
            }
        }
        mc() {
            this.l1();
            if (this.ai) {
                let a = 1;
                this.l4((b) => b.al = true);
                this.mg(a);
            }
            else {
                let b = -1;
                this.l4((c) => c.al = false);
                this.mg(b);
            }
        }
        mb() {
            this.ac = this.t ? this.ah : true;
            this.ai = true;
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        mt() {
            if (this.t) {
                this.ac = this.t;
            }
            else if (this.ai) {
                this.ac = true;
            }
            else {
                this.ac = this.af ? true : false;
            }
        }
        mg(a) {
            if ((a > 0 && this.q.playbackRate < 0) || (a < 0 && this.q.playbackRate > 0)) {
                this.q.reverse();
                this.q.finished.f((b) => {
                    if (this.q != null) {
                        this.q.commitStyles();
                    }
                    if (this.ab) {
                        this.q = null;
                        this.ab = false;
                    }
                });
                this.o.reverse();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.s) {
                        this.o = null;
                        this.s = false;
                    }
                });
                this.p.reverse();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
            }
            else {
                this.q.play();
                this.q.finished.f((b) => {
                    if (this.q != null) {
                        this.q.commitStyles();
                    }
                    if (this.ab) {
                        this.q = null;
                        this.ab = false;
                    }
                });
                this.o.play();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.s) {
                        this.o = null;
                        this.s = false;
                    }
                });
                this.p.play();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
            }
        }
        get ot() {
            return this.nn;
        }
        set ot(a) {
            let b = this.nn;
            this.nn = a;
            if (b != this.nn) {
                this.me("ActualBorderColor", b, a);
            }
        }
        get ou() {
            return this.no;
        }
        set ou(a) {
            let b = this.no;
            this.no = a;
            if (b != this.no) {
                this.me("ActualFocusBorderColor", b, a);
            }
        }
        get ca() {
            return this.am;
        }
        set ca(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.me("ActualBorderWidth", b, a);
            }
        }
        get cb() {
            return this.an;
        }
        set cb(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.me("ActualFocusBorderWidth", b, a);
            }
        }
        get m0() {
            return this.mu;
        }
        set m0(a) {
            let b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.me("ActualCornerRadius", b, a);
            }
        }
        get tg() {
            return this.ta;
        }
        set tg(a) {
            let b = this.ta;
            this.ta = a;
            if (b != this.ta) {
                this.me("ActualContentPadding", b, a);
            }
        }
        get cj() {
            return this.av;
        }
        set cj(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.me("ActualUnderlineWidth", b, a);
            }
        }
        get ci() {
            return this.au;
        }
        set ci(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.me("ActualUnderlineRippleWidth", b, a);
            }
        }
        get cf() {
            return this.ar;
        }
        set cf(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.me("ActualHoverUnderlineWidth", b, a);
            }
        }
        get ox() {
            return this.nr;
        }
        set ox(a) {
            let b = this.nr;
            this.nr = a;
            if (b != this.nr) {
                this.me("ActualUnderlineColor", b, a);
            }
        }
        get oy() {
            return this.ns;
        }
        set oy(a) {
            let b = this.ns;
            this.ns = a;
            if (b != this.ns) {
                this.me("ActualUnderlineRippleColor", b, a);
            }
        }
        get ow() {
            return this.nq;
        }
        set ow(a) {
            let b = this.nq;
            this.nq = a;
            if (b != this.nq) {
                this.me("ActualHoverUnderlineColor", b, a);
            }
        }
        get ov() {
            return this.np;
        }
        set ov(a) {
            let b = this.np;
            this.oa = a;
            if (b != this.np) {
                this.me("ActualFocusUnderlineColor", b, a);
            }
        }
        get cg() {
            return this.as;
        }
        set cg(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.me("ActualUnderlineOpacity", b, a);
            }
        }
        get ce() {
            return this.aq;
        }
        set ce(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.me("ActualHoverUnderlineOpacity", b, a);
            }
        }
        get cc() {
            return this.ao;
        }
        set cc(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.me("ActualFocusUnderlineOpacity", b, a);
            }
        }
        get cd() {
            return this.ap;
        }
        set cd(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.me("ActualFocusUnderlineRippleOpacity", b, a);
            }
        }
        get ch() {
            return this.at;
        }
        set ch(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.me("ActualUnderlineRippleOpacity", b, a);
            }
        }
        get os() {
            return this.nm;
        }
        set os(a) {
            let b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.me("ActualBackgroundColor", b, a);
            }
        }
        get cu() {
            return this.a6;
        }
        set cu(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.me("BorderWidth", b, a);
            }
        }
        get hc() {
            return this.bh;
        }
        set hc(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.me("FocusBorderWidth", b, a);
            }
        }
        get o0() {
            return this.nu;
        }
        set o0(a) {
            let b = this.nu;
            this.nu = a;
            if (b != this.nu) {
                this.me("BorderColor", b, a);
            }
        }
        get m4() {
            return this.mx;
        }
        set m4(a) {
            let b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.me("CornerRadius", b, a);
            }
        }
        get tk() {
            return this.td;
        }
        set tk(a) {
            let b = this.td;
            this.td = a;
            if (b != this.td) {
                this.me("ContentPadding", b, a);
            }
        }
        get h4() {
            return this.b9;
        }
        set h4(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.me("UnderlineWidth", b, a);
            }
        }
        get h3() {
            return this.b8;
        }
        set h3(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.me("UnderlineRippleWidth", b, a);
            }
        }
        get hg() {
            return this.bl;
        }
        set hg(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.me("HoverUnderlineWidth", b, a);
            }
        }
        get s8() {
            return this.oq;
        }
        set s8(a) {
            let b = this.oq;
            this.oq = a;
            if (b != this.oq) {
                this.me("UnderlineColor", b, a);
            }
        }
        get s9() {
            return this.or;
        }
        set s9(a) {
            let b = this.or;
            this.or = a;
            if (b != this.or) {
                this.me("UnderlineRippleColor", b, a);
            }
        }
        get st() {
            return this.ob;
        }
        set st(a) {
            let b = this.ob;
            this.ob = a;
            if (b != this.ob) {
                this.me("HoverUnderlineColor", b, a);
            }
        }
        get ss() {
            return this.oa;
        }
        set ss(a) {
            let b = this.oa;
            this.oa = a;
            if (b != this.oa) {
                this.me("FocusUnderlineColor", b, a);
            }
        }
        get h1() {
            return this.b6;
        }
        set h1(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.me("UnderlineOpacity", b, a);
            }
        }
        get hf() {
            return this.bk;
        }
        set hf(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.me("HoverUnderlineOpacity", b, a);
            }
        }
        get hd() {
            return this.bi;
        }
        set hd(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.me("FocusUnderlineOpacity", b, a);
            }
        }
        get he() {
            return this.bj;
        }
        set he(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.me("FocusUnderlineRippleOpacity", b, a);
            }
        }
        get h2() {
            return this.b7;
        }
        set h2(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.me("UnderlineRippleOpacity", b, a);
            }
        }
        get oz() {
            return this.nt;
        }
        set oz(a) {
            let b = this.nt;
            this.nt = a;
            if (b != this.nt) {
                this.me("BackgroundColor", b, a);
            }
        }
        get hh() {
            return this.bm;
        }
        set hh(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.me("LineTypeBorderWidth", b, a);
            }
        }
        get hi() {
            return this.bn;
        }
        set hi(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.me("LineTypeFocusBorderWidth", b, a);
            }
        }
        get sw() {
            return this.oe;
        }
        set sw(a) {
            let b = this.oe;
            this.oe = a;
            if (b != this.oe) {
                this.me("LineTypeFocusBorderColor", b, a);
            }
        }
        get sv() {
            return this.od;
        }
        set sv(a) {
            let b = this.od;
            this.od = a;
            if (b != this.od) {
                this.me("LineTypeBorderColor", b, a);
            }
        }
        get nk() {
            return this.my;
        }
        set nk(a) {
            let b = this.my;
            this.my = a;
            if (b != this.my) {
                this.me("LineTypeCornerRadius", b, a);
            }
        }
        get t0() {
            return this.te;
        }
        set t0(a) {
            let b = this.te;
            this.te = a;
            if (b != this.te) {
                this.me("LineTypeContentPadding", b, a);
            }
        }
        get hq() {
            return this.bv;
        }
        set hq(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.me("LineTypeUnderlineWidth", b, a);
            }
        }
        get hp() {
            return this.bu;
        }
        set hp(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.me("LineTypeUnderlineRippleWidth", b, a);
            }
        }
        get hm() {
            return this.br;
        }
        set hm(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.me("LineTypeHoverUnderlineWidth", b, a);
            }
        }
        get sz() {
            return this.oh;
        }
        set sz(a) {
            let b = this.oh;
            this.oh = a;
            if (b != this.oh) {
                this.me("LineTypeUnderlineColor", b, a);
            }
        }
        get s0() {
            return this.oi;
        }
        set s0(a) {
            let b = this.oi;
            this.oi = a;
            if (b != this.oi) {
                this.me("LineTypeUnderlineRippleColor", b, a);
            }
        }
        get sy() {
            return this.og;
        }
        set sy(a) {
            let b = this.og;
            this.ob = a;
            if (b != this.og) {
                this.me("LineTypeHoverUnderlineColor", b, a);
            }
        }
        get sx() {
            return this.of;
        }
        set sx(a) {
            let b = this.of;
            this.of = a;
            if (b != this.of) {
                this.me("LineTypeFocusUnderlineColor", b, a);
            }
        }
        get hn() {
            return this.bs;
        }
        set hn(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.me("LineTypeUnderlineOpacity", b, a);
            }
        }
        get hl() {
            return this.bq;
        }
        set hl(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.me("LineTypeHoverUnderlineOpacity", b, a);
            }
        }
        get hj() {
            return this.bo;
        }
        set hj(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.me("LineTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hk() {
            return this.bp;
        }
        set hk(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.me("LineTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get ho() {
            return this.bt;
        }
        set ho(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.me("LineTypeUnderlineRippleOpacity", b, a);
            }
        }
        get su() {
            return this.oc;
        }
        set su(a) {
            let b = this.oc;
            this.oc = a;
            if (b != this.oc) {
                this.me("LineTypeBackgroundColor", b, a);
            }
        }
        get cv() {
            return this.a7;
        }
        set cv(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.me("BoxTypeBorderWidth", b, a);
            }
        }
        get cw() {
            return this.a8;
        }
        set cw(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.me("BoxTypeFocusBorderWidth", b, a);
            }
        }
        get pa() {
            return this.n4;
        }
        set pa(a) {
            let b = this.n4;
            this.n4 = a;
            if (b != this.n4) {
                this.me("BoxTypeFocusBorderColor", b, a);
            }
        }
        get o9() {
            return this.n3;
        }
        set o9(a) {
            let b = this.n3;
            this.n3 = a;
            if (b != this.n3) {
                this.me("BoxTypeBorderColor", b, a);
            }
        }
        get m2() {
            return this.mw;
        }
        set m2(a) {
            let b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.me("BoxTypeCornerRadius", b, a);
            }
        }
        get ti() {
            return this.tc;
        }
        set ti(a) {
            let b = this.tc;
            this.tc = a;
            if (b != this.tc) {
                this.me("BoxTypeContentPadding", b, a);
            }
        }
        get c4() {
            return this.bg;
        }
        set c4(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.me("BoxTypeUnderlineWidth", b, a);
            }
        }
        get c3() {
            return this.bf;
        }
        set c3(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.me("BoxTypeUnderlineRippleWidth", b, a);
            }
        }
        get c0() {
            return this.bc;
        }
        set c0(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.me("BoxTypeHoverUnderlineWidth", b, a);
            }
        }
        get pd() {
            return this.n7;
        }
        set pd(a) {
            let b = this.n7;
            this.n7 = a;
            if (b != this.n7) {
                this.me("BoxTypeUnderlineColor", b, a);
            }
        }
        get pe() {
            return this.n8;
        }
        set pe(a) {
            let b = this.n8;
            this.n8 = a;
            if (b != this.n8) {
                this.me("BoxTypeUnderlineRippleColor", b, a);
            }
        }
        get pc() {
            return this.n6;
        }
        set pc(a) {
            let b = this.n6;
            this.ob = a;
            if (b != this.n6) {
                this.me("BoxTypeHoverUnderlineColor", b, a);
            }
        }
        get pb() {
            return this.n5;
        }
        set pb(a) {
            let b = this.n5;
            this.n5 = a;
            if (b != this.n5) {
                this.me("BoxTypeFocusUnderlineColor", b, a);
            }
        }
        get c1() {
            return this.bd;
        }
        set c1(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.me("BoxTypeUnderlineOpacity", b, a);
            }
        }
        get cz() {
            return this.bb;
        }
        set cz(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.me("BoxTypeHoverUnderlineOpacity", b, a);
            }
        }
        get cx() {
            return this.a9;
        }
        set cx(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.me("BoxTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cy() {
            return this.ba;
        }
        set cy(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.me("BoxTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get c2() {
            return this.be;
        }
        set c2(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.me("BoxTypeUnderlineRippleOpacity", b, a);
            }
        }
        get o8() {
            return this.n2;
        }
        set o8(a) {
            let b = this.n2;
            this.n2 = a;
            if (b != this.n2) {
                this.me("BoxTypeBackgroundColor", b, a);
            }
        }
        get ck() {
            return this.aw;
        }
        set ck(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.me("BorderTypeBorderWidth", b, a);
            }
        }
        get cl() {
            return this.ax;
        }
        set cl(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.me("BorderTypeFocusBorderWidth", b, a);
            }
        }
        get o3() {
            return this.nx;
        }
        set o3(a) {
            let b = this.nx;
            this.nx = a;
            if (b != this.nx) {
                this.me("BorderTypeFocusBorderColor", b, a);
            }
        }
        get o2() {
            return this.nw;
        }
        set o2(a) {
            let b = this.nw;
            this.nw = a;
            if (b != this.nw) {
                this.me("BorderTypeBorderColor", b, a);
            }
        }
        get m1() {
            return this.mv;
        }
        set m1(a) {
            let b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.me("BorderTypeCornerRadius", b, a);
            }
        }
        get th() {
            return this.tb;
        }
        set th(a) {
            let b = this.tb;
            this.tb = a;
            if (b != this.tb) {
                this.me("BorderTypeContentPadding", b, a);
            }
        }
        get ct() {
            return this.a5;
        }
        set ct(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.me("BorderTypeUnderlineWidth", b, a);
            }
        }
        get cs() {
            return this.a4;
        }
        set cs(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.me("BorderTypeUnderlineRippleWidth", b, a);
            }
        }
        get cp() {
            return this.a1;
        }
        set cp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.me("BorderTypeHoverUnderlineWidth", b, a);
            }
        }
        get o6() {
            return this.n0;
        }
        set o6(a) {
            let b = this.n0;
            this.n0 = a;
            if (b != this.n0) {
                this.me("BorderTypeUnderlineColor", b, a);
            }
        }
        get o7() {
            return this.n1;
        }
        set o7(a) {
            let b = this.n1;
            this.n1 = a;
            if (b != this.n1) {
                this.me("BorderTypeUnderlineRippleColor", b, a);
            }
        }
        get o5() {
            return this.nz;
        }
        set o5(a) {
            let b = this.nz;
            this.ob = a;
            if (b != this.nz) {
                this.me("BorderTypeHoverUnderlineColor", b, a);
            }
        }
        get o4() {
            return this.ny;
        }
        set o4(a) {
            let b = this.ny;
            this.ny = a;
            if (b != this.ny) {
                this.me("BorderTypeFocusUnderlineColor", b, a);
            }
        }
        get cq() {
            return this.a2;
        }
        set cq(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.me("BorderTypeUnderlineOpacity", b, a);
            }
        }
        get co() {
            return this.a0;
        }
        set co(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.me("BorderTypeHoverUnderlineOpacity", b, a);
            }
        }
        get cm() {
            return this.ay;
        }
        set cm(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.me("BorderTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cn() {
            return this.az;
        }
        set cn(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.me("BorderTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cr() {
            return this.a3;
        }
        set cr(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.me("BorderTypeUnderlineRippleOpacity", b, a);
            }
        }
        get o1() {
            return this.nv;
        }
        set o1(a) {
            let b = this.nv;
            this.nv = a;
            if (b != this.nv) {
                this.me("BorderTypeBackgroundColor", b, a);
            }
        }
        get hr() {
            return this.bw;
        }
        set hr(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.me("SearchTypeBorderWidth", b, a);
            }
        }
        get hs() {
            return this.bx;
        }
        set hs(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.me("SearchTypeFocusBorderWidth", b, a);
            }
        }
        get s3() {
            return this.ol;
        }
        set s3(a) {
            let b = this.ol;
            this.ol = a;
            if (b != this.ol) {
                this.me("SearchTypeFocusBorderColor", b, a);
            }
        }
        get s2() {
            return this.ok;
        }
        set s2(a) {
            let b = this.ok;
            this.ok = a;
            if (b != this.ok) {
                this.me("SearchTypeBorderColor", b, a);
            }
        }
        get nl() {
            return this.mz;
        }
        set nl(a) {
            let b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.me("SearchTypeCornerRadius", b, a);
            }
        }
        get t1() {
            return this.tf;
        }
        set t1(a) {
            let b = this.tf;
            this.tf = a;
            if (b != this.tf) {
                this.me("SearchTypeContentPadding", b, a);
            }
        }
        get h0() {
            return this.b5;
        }
        set h0(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.me("SearchTypeUnderlineWidth", b, a);
            }
        }
        get hz() {
            return this.b4;
        }
        set hz(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.me("SearchTypeUnderlineRippleWidth", b, a);
            }
        }
        get hw() {
            return this.b1;
        }
        set hw(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.me("SearchTypeHoverUnderlineWidth", b, a);
            }
        }
        get s6() {
            return this.oo;
        }
        set s6(a) {
            let b = this.oo;
            this.oo = a;
            if (b != this.oo) {
                this.me("SearchTypeUnderlineColor", b, a);
            }
        }
        get s7() {
            return this.op;
        }
        set s7(a) {
            let b = this.op;
            this.op = a;
            if (b != this.op) {
                this.me("SearchTypeUnderlineRippleColor", b, a);
            }
        }
        get s5() {
            return this.on;
        }
        set s5(a) {
            let b = this.on;
            this.ob = a;
            if (b != this.on) {
                this.me("SearchTypeHoverUnderlineColor", b, a);
            }
        }
        get s4() {
            return this.om;
        }
        set s4(a) {
            let b = this.om;
            this.om = a;
            if (b != this.om) {
                this.me("SearchTypeFocusUnderlineColor", b, a);
            }
        }
        get hx() {
            return this.b2;
        }
        set hx(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.me("SearchTypeUnderlineOpacity", b, a);
            }
        }
        get hv() {
            return this.b0;
        }
        set hv(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.me("SearchTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ht() {
            return this.by;
        }
        set ht(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.me("SearchTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hu() {
            return this.bz;
        }
        set hu(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.me("SearchTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get hy() {
            return this.b3;
        }
        set hy(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.me("SearchTypeUnderlineRippleOpacity", b, a);
            }
        }
        get s1() {
            return this.oj;
        }
        set s1(a) {
            let b = this.oj;
            this.oj = a;
            if (b != this.oj) {
                this.me("SearchTypeBackgroundColor", b, a);
            }
        }
        get ah() {
            return this.x;
        }
        set ah(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.me("IsExpanded", b, a);
            }
        }
        mk() {
            this.x = false;
            this.t = false;
            this.mt();
        }
        get aj() {
            return this.z;
        }
        set aj(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.me("IsHovered", b, a);
            }
        }
        get ai() {
            return this.y;
        }
        set ai(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.me("IsFocused", b, a);
            }
        }
        get ac() {
            return this.r;
        }
        set ac(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.me("ActualIsExpanded", b, a);
            }
        }
        get sr() {
            return this.n9;
        }
        set sr(a) {
            let b = this.n9;
            this.n9 = a;
            if (b != this.n9) {
                this.me("FocusBorderColor", b, a);
            }
        }
        get ki() {
            return this.ib;
        }
        set ki(a) {
            let b = this.ib;
            this.ib = a;
            if (b != this.ib) {
                this.me("Id", b, a);
            }
        }
        get disabled() {
            return this.w;
        }
        set disabled(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.me("IsDisabled", b, a);
            }
        }
        mf() {
        }
        onDetachedFromUI() {
            this.view.ai();
        }
        onAttachedToUI() {
            this.view.ag();
        }
        ensureShift() {
            this.l3((a) => a.view.az());
            this.l4((a) => a.view.af());
            this.l5((a) => a.view.q());
            this.l6((a) => a.view.q());
        }
        ak() {
            return this.view.g();
        }
        ia() {
            return this.b();
        }
        j9() {
            let a = this.b();
            return a.y();
        }
        b() {
            let a = new InputGroupVisualModelExport();
            a.f = this.m;
            a.e = this.j;
            a.b = AppearanceHelper.a(this.ot);
            a.o = this.ca;
            a.p = this.cb;
            a.z = this.m0;
            a.aa = this.tg;
            a.x = this.cj;
            a.w = this.ci;
            a.t = this.cf;
            a.c = AppearanceHelper.a(this.ox);
            a.d = AppearanceHelper.a(this.oy);
            a.u = this.cg;
            a.s = this.ce;
            a.q = this.cc;
            a.r = this.cd;
            a.v = this.ch;
            a.a = AppearanceHelper.a(this.os);
            a.g = this.ac;
            a.j = this.aj;
            a.i = this.ai;
            a.h = this.disabled;
            a.m = new List$1(PrefixVisualModelExport.$, 0);
            a.l = new List$1(LabelVisualModelExport.$, 0);
            a.k = new List$1(InputVisualModelExport.$, 0);
            a.n = new List$1(SuffixVisualModelExport.$, 0);
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XPrefix.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Prefix" + a.m.count.toString();
                    }
                    a.m.add1(this.inputs._inner[b].t());
                }
                else if (typeCast(XLabel.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Label" + a.l.count.toString();
                    }
                    a.l.add1(this.inputs._inner[b].au());
                }
                else if (typeCast(XInput.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Input" + a.k.count.toString();
                    }
                    a.k.add1(this.inputs._inner[b].bc());
                }
                else if (typeCast(XSuffix.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Suffix" + a.n.count.toString();
                    }
                    a.n.add1(this.inputs._inner[b].t());
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.ah(a);
        }
        get inputs() {
            return this.e;
        }
        get h7() {
            if (!this.h9.hasValue) {
                let a = 0;
                this.l4((b) => a++);
                this.h9 = toNullable(Number_$type, a);
            }
            return this.h9.value;
        }
        ml() {
            this.h9 = toNullable(Number_$type, null);
        }
        get ae() {
            return this.h7 > 0;
        }
        get al() {
            return !this.ae || this.ac;
        }
    }
    XInputGroup.$t = /*@__PURE__*/ markType(XInputGroup, 'XInputGroup', Base.$, [INotifyPropertyChanged_$type]);
    XInputGroup.i = 2;
    XInputGroup.fu = 0;
    XInputGroup.f5 = 0;
    XInputGroup.ng = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    XInputGroup.tw = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    XInputGroup.re = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rv = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.rw = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gx = 1;
    XInputGroup.gw = 2;
    XInputGroup.f9 = 2;
    XInputGroup.sf = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.sg = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.ry = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rx = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gu = 1;
    XInputGroup.f8 = 1;
    XInputGroup.f6 = 1;
    XInputGroup.f7 = 1;
    XInputGroup.gv = 0;
    XInputGroup.rd = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.ga = 0;
    XInputGroup.gb = 0;
    XInputGroup.nh = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    XInputGroup.tx = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    XInputGroup.r0 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.r1 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.r2 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gj = 1;
    XInputGroup.gi = 2;
    XInputGroup.gf = 2;
    XInputGroup.r5 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.r6 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.r4 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.r3 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gg = 1;
    XInputGroup.ge = 1;
    XInputGroup.gc = 1;
    XInputGroup.gd = 1;
    XInputGroup.gh = 0;
    XInputGroup.rz = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.fv = 0;
    XInputGroup.fw = 0;
    XInputGroup.nf = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    XInputGroup.tv = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.ro = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rp = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.rq = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.f4 = 1;
    XInputGroup.f3 = 2;
    XInputGroup.f0 = 2;
    XInputGroup.rt = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.ru = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.rs = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rr = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.f1 = 1;
    XInputGroup.fz = 1;
    XInputGroup.fx = 1;
    XInputGroup.fy = 1;
    XInputGroup.f2 = 0;
    XInputGroup.rn = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    XInputGroup.fk = 1;
    XInputGroup.fl = 2;
    XInputGroup.ne = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    XInputGroup.tu = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.rg = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rh = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.ri = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.ft = 1;
    XInputGroup.fs = 2;
    XInputGroup.fp = 2;
    XInputGroup.rl = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rm = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.rk = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.rj = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.fq = 0;
    XInputGroup.fo = 0;
    XInputGroup.fm = 0;
    XInputGroup.fn = 0;
    XInputGroup.fr = 0;
    XInputGroup.rf = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.gk = 1;
    XInputGroup.gl = 2;
    XInputGroup.ni = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    XInputGroup.ty = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.r8 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.r9 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.sa = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gt = 1;
    XInputGroup.gs = 2;
    XInputGroup.gp = 2;
    XInputGroup.sd = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.se = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.sc = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XInputGroup.sb = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XInputGroup.gq = 0;
    XInputGroup.go = 0;
    XInputGroup.gm = 0;
    XInputGroup.gn = 0;
    XInputGroup.gr = 0;
    XInputGroup.r7 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.d1 = 0;
    XInputGroup.ec = 0;
    XInputGroup.na = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    XInputGroup.tq = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    XInputGroup.py = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qf = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qg = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.e4 = 1;
    XInputGroup.e3 = 2;
    XInputGroup.eg = 2;
    XInputGroup.qz = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.q0 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qi = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qh = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.e1 = 1;
    XInputGroup.ef = 1;
    XInputGroup.ed = 1;
    XInputGroup.ee = 1;
    XInputGroup.e2 = 0;
    XInputGroup.px = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.eh = 0;
    XInputGroup.ei = 0;
    XInputGroup.nb = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    XInputGroup.tr = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    XInputGroup.qk = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.ql = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qm = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.eq = 1;
    XInputGroup.ep = 2;
    XInputGroup.em = 2;
    XInputGroup.qp = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qq = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qo = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qn = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.en = 1;
    XInputGroup.el = 1;
    XInputGroup.ej = 1;
    XInputGroup.ek = 1;
    XInputGroup.eo = 0;
    XInputGroup.qj = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.d2 = 0;
    XInputGroup.d3 = 0;
    XInputGroup.m9 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    XInputGroup.tp = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.p8 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.p9 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qa = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.eb = 1;
    XInputGroup.ea = 2;
    XInputGroup.d7 = 2;
    XInputGroup.qd = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qe = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qc = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qb = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.d8 = 1;
    XInputGroup.d6 = 1;
    XInputGroup.d4 = 1;
    XInputGroup.d5 = 1;
    XInputGroup.d9 = 0;
    XInputGroup.p7 = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    XInputGroup.dr = 1;
    XInputGroup.ds = 2;
    XInputGroup.m8 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    XInputGroup.to = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.p0 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.p1 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.p2 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.d0 = 1;
    XInputGroup.dz = 2;
    XInputGroup.dw = 2;
    XInputGroup.p5 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.p6 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.p4 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.p3 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.dx = 0;
    XInputGroup.dv = 0;
    XInputGroup.dt = 0;
    XInputGroup.du = 0;
    XInputGroup.dy = 0;
    XInputGroup.pz = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.er = 1;
    XInputGroup.es = 2;
    XInputGroup.nc = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    XInputGroup.ts = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    XInputGroup.qs = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qt = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qu = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.e0 = 1;
    XInputGroup.ez = 2;
    XInputGroup.ew = 2;
    XInputGroup.qx = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qy = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.qw = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    XInputGroup.qv = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XInputGroup.ex = 0;
    XInputGroup.ev = 0;
    XInputGroup.et = 0;
    XInputGroup.eu = 0;
    XInputGroup.ey = 0;
    XInputGroup.qr = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XInputGroup.h8 = 0;
    return XInputGroup;
})();
/**
 * @hidden
 */
export let XInputGroupInputCollection = /*@__PURE__*/ (() => {
    class XInputGroupInputCollection extends ObservableCollection$1 {
        constructor() {
            super(XInputGroupItem.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    XInputGroupInputCollection.$t = /*@__PURE__*/ markType(XInputGroupInputCollection, 'XInputGroupInputCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(XInputGroupItem.$));
    return XInputGroupInputCollection;
})();
/**
 * @hidden
 */
export let XLabel = /*@__PURE__*/ (() => {
    class XLabel extends XInputGroupItem {
        constructor() {
            super();
            this.n = 0;
            this._view = null;
            this.aa = null;
            this.z = null;
            this.r = 0;
            this.q = 1;
            this.cr = ThemeResolver.e(XLabel.o, XLabel.da, XLabel.c3);
            this.co = ThemeResolver.e(XLabel.o, XLabel.c7, XLabel.c0);
            this.cp = ThemeResolver.e(XLabel.o, XLabel.c8, XLabel.c1);
            this.cq = ThemeResolver.e(XLabel.o, XLabel.c9, XLabel.c2);
            this.u = null;
            this.cv = XLabel.db;
            this.cs = XLabel.c4;
            this.ct = XLabel.c5;
            this.k = 0;
            this.af = false;
            this.ad = false;
            this.v = null;
            this.cu = null;
            this.a2 = "ig-label-" + XLabel.at++;
            this.ay = "inline-block";
            this.az = "inline-block";
            this.a0 = null;
            this.av = "center";
            this.aw = "center";
            this.ar = 0;
            this.ab = false;
            this.a1 = null;
            this.ax = null;
            this.a3 = null;
            this.ae = false;
            this.ai = false;
            this.ac = false;
            this.ah = false;
            this.ag = false;
            this.ap = false;
            let a = new LabelView();
            a.c = this;
            this.view = a;
            this.view.ab();
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        b8() {
            this.view.s();
            let a = false;
            if (this.aa == null) {
                let b = new TransformGroup();
                b.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.view.j();
                    return $ret;
                })()));
                b.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })()));
                let c = -(this.view.i() * 1.3);
                if (this.s == 2) {
                    c = -(this.view.i() * 1.05);
                }
                if (this.s == 3) {
                    c = -(this.view.i() * 1.01);
                }
                let d = new TransformGroup();
                d.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.l == 2 ? c : -(this.view.i() * 0.65);
                    return $ret;
                })()));
                d.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.75;
                    $ret.m = 0.75;
                    return $ret;
                })()));
                this.aa = KeyFrameAnimationFactory.f.c(this.view.b(this.i).m(new AnimationKeyFrameProperty(14, b), new AnimationKeyFrameProperty(2, BrushUtil.g(0, 255, 255, 255))).m(new AnimationKeyFrameProperty(14, d), new AnimationKeyFrameProperty(2, BrushUtil.g(this.l == 2 ? 255 : 0, 255, 255, 255))));
            }
            if (this.z == null) {
                this.z = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(7, this.cz)).m(new AnimationKeyFrameProperty(7, this.cw)));
            }
        }
        ci(a, b) {
            if ((b > 0 && a.playbackRate < 0) || (b < 0 && a.playbackRate > 0)) {
                a.reverse();
                if (this.ap) {
                    a.finish();
                    this.b9(a);
                    return;
                }
                a.finished.f((c) => this.b9(a));
            }
            else {
                a.play();
                if (this.ap) {
                    a.finish();
                    this.b9(a);
                    return;
                }
                a.finished.f((c) => this.b9(a));
            }
        }
        b9(a) {
            a.commitStyles();
            if (a == this.aa && this.ah) {
                this.aa = null;
            }
            if (a == this.z && this.ag) {
                this.z = null;
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "BaseTheme":
                    this.cl(this.p);
                    this.cn();
                    break;
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                case "HighlightTextColor":
                case "HoverHighlightTextColor":
                    this.cn();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                case "ActualHighlightTextColor":
                case "ActualHoverHighlightTextColor":
                    if (this.aa != null) {
                        if (this.aa.playState == 3) {
                            this.aa = null;
                        }
                        else {
                            this.ah = true;
                        }
                    }
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    this.cm();
                    break;
                case "Text":
                    this.view.ae();
                    break;
                case "Density":
                    this.s = this.t == 0 ? 1 : this.t;
                    break;
                case "ActualDensity":
                    this.view.ag();
                    this.view.af();
                    break;
                case "InputGroup":
                    this.view.af();
                    break;
                case "IsHighlighted":
                    this.cc();
                    break;
                case "IsShifted":
                    this.cd();
                    break;
                case "ShiftType":
                    if (this.aa != null) {
                        if (this.aa.playState == 3) {
                            this.aa = null;
                        }
                        else {
                            this.ah = true;
                        }
                    }
                    this.cg();
                    break;
                case "Display":
                    this.view.y();
                    break;
                case "FlexDirection":
                    this.view.z();
                    break;
                case "FlexGrow":
                    this.view.aa();
                    break;
                case "AlignItems":
                    this.view.t();
                    break;
                case "AlignSelf":
                    this.view.u();
                    break;
            }
        }
        cg() {
            this.view.af();
        }
        cd() {
            this.b8();
            let a = 1;
            let b = this.an;
            if (!b) {
                a = -1;
            }
            this.ci(this.aa, a);
        }
        cc() {
            this.b8();
            let a = 1;
            let b = this.al;
            if (!b) {
                a = -1;
            }
            this.ci(this.z, a);
        }
        cn() {
            this.cz = this.df != null ? this.df : XLabel.db;
            this.cy = this.de != null ? this.de : XLabel.db;
            this.cw = this.dc != null ? this.dc : XLabel.c4;
            this.w = this.y != null ? this.y : XLabel.x;
        }
        cm() {
            if (this.w != null) {
                this.view.ai(this.w);
            }
            this.view.ad(this.cz);
        }
        cl(a) {
            XLabel.db = ThemeResolver.e(a, XLabel.da, XLabel.c3);
            XLabel.c4 = ThemeResolver.e(a, XLabel.c7, XLabel.c0);
            XLabel.c6 = ThemeResolver.e(a, XLabel.c9, XLabel.c2);
            XLabel.c5 = ThemeResolver.e(a, XLabel.c8, XLabel.c1);
        }
        get t() {
            return this.r;
        }
        set t(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get cz() {
            return this.cr;
        }
        set cz(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.g("ActualTextColor", b, a);
            }
        }
        get cw() {
            return this.co;
        }
        set cw(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.g("ActualHighlightTextColor", b, a);
            }
        }
        get cx() {
            return this.cp;
        }
        set cx(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.g("ActualHoverHighlightTextColor", b, a);
            }
        }
        get cy() {
            return this.cq;
        }
        set cy(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get df() {
            return this.cv;
        }
        set df(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.g("TextColor", b, a);
            }
        }
        get dc() {
            return this.cs;
        }
        set dc(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.g("HighlightTextColor", b, a);
            }
        }
        get dd() {
            return this.ct;
        }
        set dd(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.g("HoverHighlightTextColor", b, a);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.g("ShiftType", enumGetBox(LabelShiftType_$type, b), enumGetBox(LabelShiftType_$type, a));
            }
        }
        get an() {
            return this.af;
        }
        set an(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.g("IsShifted", b, a);
            }
        }
        ck(a, b = true) {
            let c = this.ap;
            if (!b) {
                this.ap = true;
            }
            try {
                this.an = a;
            }
            finally {
                if (!b) {
                    this.ap = c;
                }
            }
        }
        get al() {
            return this.ad;
        }
        set al(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.g("IsHighlighted", b, a);
            }
        }
        ce() {
            this.am = true;
        }
        cf() {
            this.am = false;
        }
        get y() {
            return this.v;
        }
        set y(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("TextStyle", b, a);
            }
        }
        get de() {
            return this.cu;
        }
        set de(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.g("HoverTextColor", b, a);
            }
        }
        get bu() {
            return this.a2;
        }
        set bu(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.g("Id", b, a);
            }
        }
        get bi() {
            return this.ay;
        }
        set bi(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.g("Display", b, a);
            }
        }
        get bl() {
            return this.az;
        }
        set bl(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.g("FlexDirection", b, a);
            }
        }
        get bn() {
            return this.a0;
        }
        set bn(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.g("FlexGrow", b, a);
            }
        }
        get ba() {
            return this.av;
        }
        set ba(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.g("AlignItems", b, a);
            }
        }
        get bc() {
            return this.aw;
        }
        set bc(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.g("AlignSelf", b, a);
            }
        }
        get aj() {
            return this.ab;
        }
        get as() {
            return this.ar;
        }
        set as(a) {
            let b = this.ar;
            this.ar = a;
            this.ab = true;
            if (b != this.ar) {
                this.g("TabIndex", b, a);
            }
        }
        get bp() {
            return this.a1;
        }
        set bp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.g("TabIndex", b, a);
            }
        }
        get be() {
            return this.ax;
        }
        set be(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.g("AriaLabel", b, a);
            }
        }
        get text() {
            return this.a3;
        }
        set text(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.g("Text", b, a);
            }
        }
        get am() {
            return this.ae;
        }
        set am(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IsHover", b, a);
            }
        }
        get aq() {
            return this.ai;
        }
        set aq(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.g("Value", b, a);
            }
        }
        get disabled() {
            return this.ac;
        }
        set disabled(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("IsDisabled", b, a);
            }
        }
        ch() {
            this.view.ae();
        }
        onDetachedFromUI() {
            this.view.x();
        }
        onAttachedToUI() {
            this.view.v();
        }
        ao() {
            return this.view.f();
        }
        au() {
            return this.j();
        }
        bk() {
            let a = this.j();
            return a.q();
        }
        j() {
            let a = new LabelVisualModelExport();
            let b = this.view.n;
            a.c = this.p;
            a.e = this.t;
            a.d = this.s;
            a.a = AppearanceHelper.a(NativeUI.ah(b));
            a.b = this.l;
            a.i = this.an;
            a.g = this.al;
            a.m = this.bi;
            a.n = this.bl;
            a.o = this.bn;
            a.l = this.ba;
            a.r = this.text;
            a.h = this.am;
            a.j = this.aq;
            a.f = this.disabled;
            a.p = this.e;
            if (this.w != null) {
                let c = this.w;
                if (this.view != null && c.n == null) {
                    let d = this.view.k;
                    let e = FontUtil.getFontInfoFromString(d, c.fontString);
                    c.n = e.n;
                    c.d = e.d;
                    c.o = e.o;
                    c.q = e.q;
                    c.r = e.r;
                    c.s = e.s;
                }
                if (c.n != null) {
                    a.s = c.n;
                }
                if (!isNaN_(c.d)) {
                    a.k = c.d;
                }
                if (c.s != null) {
                    a.w = c.s;
                }
                if (c.q != null) {
                    a.u = c.q;
                }
                if (c.o != null) {
                    a.t = c.q;
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.w(a);
        }
    }
    XLabel.$t = /*@__PURE__*/ markType(XLabel, 'XLabel', XInputGroupItem.$);
    XLabel.da = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    XLabel.c7 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XLabel.c9 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    XLabel.c8 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    XLabel.c3 = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    XLabel.c0 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XLabel.c2 = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    XLabel.c1 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XLabel.o = 2;
    XLabel.db = /*@__PURE__*/ ThemeResolver.e(XLabel.o, XLabel.da, XLabel.c3);
    XLabel.c4 = /*@__PURE__*/ ThemeResolver.e(XLabel.o, XLabel.c7, XLabel.c0);
    XLabel.c6 = /*@__PURE__*/ ThemeResolver.e(XLabel.o, XLabel.c9, XLabel.c2);
    XLabel.c5 = /*@__PURE__*/ ThemeResolver.e(XLabel.o, XLabel.c8, XLabel.c1);
    XLabel.x = null;
    XLabel.at = 0;
    return XLabel;
})();
/**
 * @hidden
 */
export let XInput = /*@__PURE__*/ (() => {
    class XInput extends XInputGroupItem {
        constructor() {
            super();
            this.t = null;
            this.a3 = 0;
            this.a4 = 0;
            this.p = 0;
            this.bl = "";
            this.bf = "";
            this.ae = false;
            this.bg = null;
            this.af = false;
            this.an = false;
            this._view = null;
            this.m = 0;
            this.v = 1;
            this.u = 1;
            this.bk = null;
            this.bn = "_";
            this.ah = false;
            this.dq = XInput.dw;
            this.dp = XInput.dv;
            this.y = null;
            this.ds = XInput.dw;
            this.keyDown = null;
            this.keyUp = null;
            this.keyPress = null;
            this.gotFocus = null;
            this.lostFocus = null;
            this.mouseDown = null;
            this.mouseUp = null;
            this.z = null;
            this.bj = "text";
            this.bm = "text";
            this.dr = null;
            this.bi = "ig-input-" + XInput.bb++;
            this.a5 = 0;
            this.ag = false;
            this.bh = null;
            this.be = null;
            this.ak = false;
            this.bd = null;
            this.bo = null;
            this.aj = false;
            this.ai = false;
            this.al = false;
            this.change = null;
            this.changing = null;
            this.compositionStart = null;
            this.compositionEnd = null;
            this.am = true;
            this.ad = null;
            this.aw = false;
            this.t = new MaskParsingService();
            let a = new InputView();
            a.b = this;
            this.view = a;
            this.view.ao();
            XInput.ab = new FontInfo();
            XInput.ab.n = "'Segoe UI', Verdana";
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("ShiftType", enumGetBox(InputShiftType_$type, b), enumGetBox(InputShiftType_$type, a));
            }
        }
        get x() {
            return this.v;
        }
        set x(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get b9() {
            return this.bk;
        }
        set b9(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.g("Mask", b, a);
            }
        }
        get cd() {
            return this.bn;
        }
        set cd(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.g("PromptChar", b, a);
            }
        }
        get aq() {
            return this.ah;
        }
        set aq(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g("IncludeLiterals", b, a);
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                    this.dm();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                    this.dl();
                    break;
                case "Value":
                    if (!this.ai) {
                        this.view.at(this.cj);
                        if (this.b != null) {
                            this.b.mt();
                        }
                        if (this.b9 != null && !this.an) {
                            this.dn(this.cj);
                        }
                    }
                    break;
                case "Density":
                    this.w = this.x == 0 ? 1 : this.x;
                    break;
                case "ActualDensity":
                    this.view.a0();
                    this.view.az();
                    break;
                case "InputGroup":
                    this.c0();
                    break;
                case "ShiftType":
                    this.db();
                    break;
                case "InputType":
                    this.dc();
                    break;
                case "Placeholder":
                    this.da();
                    break;
                case "Mask":
                    this.cb = this.b9;
                    break;
                case "PromptChar": break;
                case "IncludeLiterals": break;
                case "IsShown":
                    this.c1();
                    break;
                case "IsDisabled":
                    this.view.au(this.aj);
                    break;
                case "IsReadOnly":
                    this.view.av(this.al);
                    break;
            }
        }
        da() {
            this.view.aq();
        }
        dc() {
            this.view.as();
        }
        db() {
            this.view.az();
        }
        c0() {
            this.view.az();
        }
        dm() {
            this.du = this.dy != null ? this.dy : XInput.dw;
            this.dt = this.dx != null ? this.dx : XInput.dw;
            this.aa = this.ac != null ? this.ac : XInput.ab;
        }
        dl() {
            if (this.aa != null) {
                this.view.a2(this.aa);
            }
            NativeUI.o(this.view.o, this.du);
        }
        get du() {
            return this.dq;
        }
        set du(a) {
            let b = this.dq;
            this.dq = a;
            if (b != this.dq) {
                this.g("ActualTextColor", b, a);
            }
        }
        get dt() {
            return this.dp;
        }
        set dt(a) {
            let b = this.dp;
            this.dp = a;
            if (b != this.dp) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get aa() {
            return this.y;
        }
        set aa(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get dy() {
            return this.ds;
        }
        set dy(a) {
            let b = this.ds;
            this.ds = a;
            if (b != this.ds) {
                this.g("TextColor", b, a);
            }
        }
        cr() {
            if (this.b9 != null) {
                this.dj(this.cj);
            }
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        cz() {
            if (this.b9 != null) {
                this.dk(this.cj);
            }
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        c2(a) {
            if (this.b9 != null) {
                let b = a.keyCode;
                if ((b == 17 && b == 90) || (b == 17 && b == 89)) {
                    a.preventDefault();
                }
                this.p = b;
                this.a4 = this.a7();
                this.a3 = this.a6();
            }
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        c4(a) {
            if (null != this.keyUp) {
                this.keyUp(this, a);
            }
        }
        c3(a) {
            if (null != this.keyPress) {
                this.keyPress(this, a);
            }
        }
        c5(a) {
            if (null != this.mouseDown) {
                this.mouseDown(this, a);
            }
        }
        c8(a) {
            if (null != this.mouseUp) {
                this.mouseUp(this, a);
            }
        }
        c9() {
            if (this.b9 != null) {
                this.bl = this.cj;
                this.a4 = this.a7();
            }
        }
        cx() {
            if (this.b9 != null) {
                if (!this.ae) {
                    this.dk(this.bf);
                }
            }
        }
        cy() {
            if (this.b9 != null) {
                if (!this.ae) {
                    this.dj(this.cj);
                }
            }
        }
        cs() {
            this.ai = true;
            this.cj = this.view.q();
            if (this.change != null) {
                this.change(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cj;
                    $ret.isCompositionInProgress = this.view.e;
                    return $ret;
                })()));
            }
            this.ai = false;
        }
        ct() {
            this.ai = true;
            this.cj = this.view.q();
            this.ai = false;
            if (this.b9 != null) {
                this.an = true;
                if (this.af) {
                    this.a4 = this.a7();
                }
                if (this.cj.length < this.bl.length && this.p == 229) {
                    this.p = 8;
                }
                let a = this.a7();
                let b = this.a6();
                let c = "";
                switch (this.p) {
                    case 46:
                        this.a3 = this.a4 == this.a3 ? ++this.a3 : this.a3;
                        break;
                    case 8:
                        this.a4 = this.a7();
                        break;
                    default:
                        c = this.cj.substr(this.a4, this.a6() - this.a4);
                        break;
                }
                let d = new MaskOptions();
                d.a = this.b9;
                d.b = this.cd;
                let e = this.t.a(this.bl, c, d, this.a4, this.a3);
                this.cj = e.b;
                if (this.p == 8) {
                    e.a = this.a4;
                }
                this.di(e.a, e.a);
                let f = this.t.i(this.cj, d);
                this.bf = this.aq ? this.cj : f;
                this.cl();
                this.an = false;
            }
            this.ai = true;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cj;
                    $ret.isCompositionInProgress = this.view.e;
                    return $ret;
                })()));
            }
            this.ai = false;
        }
        cv() {
            if (this.compositionStart != null) {
                this.compositionStart(this, new EventArgs());
            }
        }
        cu() {
            if (this.compositionEnd != null) {
                this.compositionEnd(this, new EventArgs());
            }
        }
        c6() {
            this.as = true;
        }
        c7() {
            this.as = false;
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.g("TextStyle", b, a);
            }
        }
        get b3() {
            return this.bj;
        }
        set b3(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.g("InputType", b, a);
            }
        }
        get cb() {
            return this.bm;
        }
        set cb(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.g("Placeholder", b, a);
            }
        }
        get dx() {
            return this.dr;
        }
        set dx(a) {
            let b = this.dr;
            this.dr = a;
            if (b != this.dr) {
                this.g("HoverTextColor", b, a);
            }
        }
        get b0() {
            return this.bi;
        }
        set b0(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.g("Id", b, a);
            }
        }
        get ao() {
            return this.ag;
        }
        get ba() {
            return this.a5;
        }
        set ba(a) {
            let b = this.a5;
            this.a5 = a;
            this.ag = true;
            if (b != this.a5) {
                this.g("TabIndex", b, a);
            }
        }
        get bx() {
            return this.bh;
        }
        set bx(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.g("TabIndex", b, a);
            }
        }
        get bt() {
            return this.be;
        }
        set bt(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.g("AriaLabel", b, a);
            }
        }
        get as() {
            return this.ak;
        }
        set as(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.g("IsHover", b, a);
            }
        }
        get cj() {
            return this.bo;
        }
        set cj(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.g("Value", b, a);
            }
        }
        get ap() {
            return !stringIsNullOrEmpty(this.cj);
        }
        get disabled() {
            return this.aj;
        }
        set disabled(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.g("IsDisabled", b, a);
            }
        }
        get readonly() {
            return this.al;
        }
        set readonly(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.g("IsReadOnly", b, this.al);
            }
        }
        dd() {
        }
        onDetachedFromUI() {
            this.view.am();
        }
        onAttachedToUI() {
            this.view.aj();
        }
        av() {
            return this.view.f();
        }
        bc() {
            return this.j();
        }
        bw() {
            let a = this.j();
            return a.n();
        }
        j() {
            let a = new InputVisualModelExport();
            let b = this.view.o;
            a.h = this.view.j.rootWrapper.getNativeElement().offsetTop;
            a.f = this.view.j.rootWrapper.getNativeElement().offsetLeft;
            a.b = this.n;
            a.c = this.w;
            a.j = this.b9;
            a.m = this.cd;
            a.d = this.aq;
            a.a = AppearanceHelper.a(NativeUI.ah(b));
            a.i = this.b3;
            a.l = this.cb;
            a.e = this.as;
            a.t = this.cj;
            a.k = this.e;
            if (this.aa != null) {
                let c = this.aa;
                if (this.view != null && c.n == null) {
                    let d = this.view.j;
                    let e = FontUtil.getFontInfoFromString(d, c.fontString);
                    c.n = e.n;
                    c.d = e.d;
                    c.o = e.o;
                    c.q = e.q;
                    c.r = e.r;
                    c.s = e.s;
                }
                if (c.n != null) {
                    a.o = c.n;
                }
                if (!isNaN_(c.d)) {
                    a.g = c.d;
                }
                if (c.s != null) {
                    a.s = c.s;
                }
                if (c.q != null) {
                    a.q = c.q;
                }
                if (c.o != null) {
                    a.p = c.q;
                }
            }
            return a;
        }
        di(a, b) {
            this.view.ax(a, b);
        }
        provideContainer(a) {
            this.view.al(a);
        }
        cm() {
            this.cr();
            this.view.ak();
        }
        focus(a = false) {
            this.cz();
            this.view.an(a);
        }
        dg() {
            this.view.ar();
        }
        dk(a) {
            this.an = true;
            let b = new MaskOptions();
            b.a = this.b9;
            b.b = this.cd;
            this.cj = this.t.h(this.cj, b);
            this.bl = this.cj;
            this.an = false;
        }
        dj(a) {
            this.an = true;
            let b = new MaskOptions();
            b.a = this.b9;
            b.b = this.cd;
            if (a == this.t.h(null, b)) {
                this.cj = "";
            }
            this.an = false;
        }
        dn(a) {
            let b = new MaskOptions();
            b.a = this.b9;
            b.b = this.cd;
            if (this.cd != null && this.cd.length > 1) {
                b.b = this.cd.substr(0, 1);
            }
            this.cj = a != null ? this.t.h(a, b) : "";
            this.bf = this.aq ? this.cj : a;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cj;
                    $ret.isCompositionInProgress = this.view.e;
                    return $ret;
                })()));
            }
        }
        cl() {
            this.bl = this.cj;
            this.af = false;
            this.a4 = 0;
            this.a3 = 0;
            this.p = 0;
        }
        a7() {
            let a = this.view.n();
            let b = this.view.m();
            return a == b && this.af ? b - this.bg.length : a;
        }
        a6() {
            return this.view.m();
        }
        get selectionStart() {
            return this.a7();
        }
        set selectionStart(a) {
            this.view.ay(a);
        }
        get selectionEnd() {
            return this.a6();
        }
        set selectionEnd(a) {
            this.view.aw(a);
        }
        get au() {
            return this.am;
        }
        set au(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.g("IsShown", b, a);
            }
        }
        dh(a, b = true) {
            let c = this.aw;
            if (!b) {
                this.aw = true;
            }
            try {
                this.au = a;
            }
            finally {
                if (!b) {
                    this.aw = c;
                }
            }
        }
        c1() {
            this.co();
            this.de(this.ad, this.au);
        }
        co() {
            this.view.ai();
            if (this.ad == null) {
                this.ad = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        de(a, b) {
            let c = a.playbackRate < 0;
            if (b != c) {
                a.play();
            }
            else {
                a.reverse();
            }
            if (this.aw) {
                a.finish();
                a.commitStyles();
                return;
            }
            a.finished.f((d) => a.commitStyles());
        }
    }
    XInput.$t = /*@__PURE__*/ markType(XInput, 'XInput', XInputGroupItem.$);
    XInput.dw = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    XInput.dv = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    XInput.ab = null;
    XInput.bb = 0;
    return XInput;
})();
