import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { CheckboxLabelPosition } from "./CheckboxLabelPosition";
import { CheckboxChangeEventArgs } from "./CheckboxChangeEventArgs";
import { CheckboxVisualModelExport } from "./CheckboxVisualModelExport";
/**
 * @hidden
 */
export declare class CheckboxView extends Base {
    static $t: Type;
    constructor();
    c: XCheckbox;
    ad(): void;
    i(): boolean;
    private l;
    private f;
    private j;
    ab(a: DomRenderer): void;
    private t;
    ag(): void;
    ae(): void;
    private u;
    private x;
    private w;
    private h;
    private v;
    y(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    private z;
    private g;
    private q;
    private m;
    private p;
    get r(): any;
    get e(): XRipple;
    private n;
    get s(): any;
    private d;
    private o;
    aa(): void;
    ac(): void;
    af(): void;
    ah(a: Brush, b: Brush): void;
    k(): number;
}
/**
 * @hidden
 */
export declare class XCheckbox extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    get view(): CheckboxView;
    set view(a: CheckboxView);
    private g;
    get i(): BaseControlTheme;
    set i(a: BaseControlTheme);
    destroy(): void;
    protected cl(a: string, b: any, c: any): void;
    private cr;
    protected cn(a: string, b: any, c: any): void;
    private n;
    private cq;
    private ct;
    ab: boolean;
    private c3;
    get dt(): Brush;
    set dt(a: Brush);
    private cy;
    get c8(): Brush;
    set c8(a: Brush);
    private c0;
    get da(): Brush;
    set da(a: Brush);
    private c2;
    get ds(): Brush;
    set ds(a: Brush);
    private cx;
    get c7(): Brush;
    set c7(a: Brush);
    private c4;
    get du(): Brush;
    set du(a: Brush);
    private c1;
    get db(): Brush;
    set db(a: Brush);
    static dn: Brush;
    static dk: Brush;
    static as: number;
    static dj: Brush;
    static at: number;
    static dl: Brush;
    static au: number;
    static dm: Brush;
    static di: Brush;
    static df: Brush;
    static ap: number;
    static de: Brush;
    static aq: number;
    static dg: Brush;
    static ar: number;
    static dh: Brush;
    static h: BaseControlTheme;
    dr: Brush;
    dd: Brush;
    an: number;
    dc: Brush;
    ao: number;
    dp: Brush;
    av: number;
    dq: Brush;
    private cu;
    private cz;
    get c9(): Brush;
    set c9(a: Brush);
    private cw;
    get c6(): Brush;
    set c6(a: Brush);
    private af;
    get al(): number;
    set al(a: number);
    private ac;
    get ai(): number;
    set ai(a: number);
    private ag;
    get am(): number;
    set am(a: number);
    private ah;
    get aw(): number;
    set aw(a: number);
    private ae;
    get ak(): number;
    set ak(a: number);
    private ad;
    get aj(): number;
    set aj(a: number);
    private cv;
    get c5(): Brush;
    set c5(a: Brush);
    private static a2;
    private a9;
    get by(): string;
    set by(a: string);
    private static a1;
    private a8;
    get bw(): string;
    set bw(a: string);
    private ba;
    get labelId(): string;
    set labelId(a: string);
    private bb;
    get b7(): string;
    set b7(a: string);
    private ay;
    private o;
    get v(): boolean;
    get a0(): number;
    set a0(a: number);
    private ax;
    get az(): number;
    set az(a: number);
    private a7;
    get bl(): string;
    set bl(a: string);
    private a6;
    get bk(): string;
    set bk(a: string);
    private a3;
    get a5(): any;
    set a5(a: any);
    private r;
    get focused(): boolean;
    set focused(a: boolean);
    change: (sender: any, args: CheckboxChangeEventArgs) => void;
    private d;
    get e(): CheckboxLabelPosition;
    set e(a: CheckboxLabelPosition);
    private l;
    get t(): boolean;
    set t(a: boolean);
    private p;
    get checked(): boolean;
    set checked(a: boolean);
    private s;
    get indeterminate(): boolean;
    set indeterminate(a: boolean);
    private q;
    get disabled(): boolean;
    set disabled(a: boolean);
    private m;
    get u(): boolean;
    set u(a: boolean);
    cm(): void;
    private get a();
    private ch;
    toggle(): void;
    private cs;
    private j;
    private k;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    onContentReady(): void;
    protected aa(): boolean;
    a4(): any;
    bv(): string;
    b(): CheckboxVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
